#
# Copyright (C) 1993 Brian Kahn, Steve O'Keefe, Bob Noel
# Copyright (C) 1993 All Rights Reserved
# Copyright (C) 1993 Thu May 13 1993
#
# Complete copyright is held by each of the authors
# Permission to distribute and use for educational purposes
#
# 

#!/usr/local/bin/wish -f
# Program: xpetri
# Tcl version: 6.7 (Tcl/Tk/XF)
# Tk version: 3.2
# XF version: 2.2
#

# module inclusion
global env
global xfLoadPath
if {[info exists env(XF_LOAD_PATH)]} {
  if {[string first $env(XF_LOAD_PATH) /usr/local/lib/] == -1} {
    set xfLoadPath $env(XF_LOAD_PATH):/usr/local/lib/
  } {
    set xfLoadPath /usr/local/lib/
  }
} {
  set xfLoadPath /usr/local/lib/
}

global argc
global argv
global tkVersion
global xfLoadInfo
global xfLoadPath
set xfLoadInfo 0
set tmpArgv ""
for {set counter 0} {$counter < $argc} {incr counter 1} {
  case [string tolower [lindex $argv $counter]] in {
    {-xfloadpath} {
      incr counter 1
      set xfLoadPath "[lindex $argv $counter]:$xfLoadPath"
    }
    {-xfstartup} {
      incr counter 1
      source [lindex $argv $counter]
    }
    {-xfbindfile} {
      incr counter 1
      set env(XF_BIND_FILE) "[lindex $argv $counter]"
    }
    {-xfcolorfile} {
      incr counter 1
      set env(XF_COLOR_FILE) "[lindex $argv $counter]"
    }
    {-xfcursorfile} {
      incr counter 1
      set env(XF_CURSOR_FILE) "[lindex $argv $counter]"
    }
    {-xffontfile} {
      incr counter 1
      set env(XF_FONT_FILE) "[lindex $argv $counter]"
    }
    {-xfmodelmono} {
      if {$tkVersion >= 3.0} {
        tk colormodel . monochrome
      }
    }
    {-xfmodelcolor} {
      if {$tkVersion >= 3.0} {
        tk colormodel . color
      }
    }
    {-xfloading} {
      set xfLoadInfo 1
    }
    {-xfnoloading} {
      set xfLoadInfo 0
    }
    {default} {
      lappend tmpArgv [lindex $argv $counter]
    }
  }
}
set argv $tmpArgv
set argc [llength $tmpArgv]
unset counter
unset tmpArgv


# procedure to show window .top0
proc ShowWindow.top0 {args} {# xf ignore me 7

  # build widget .top0
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top0"
  } {
    catch "destroy .top0"
  }
  toplevel .top0 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # Window manager configurations
  global tkVersion
  wm positionfrom .top0 user
  wm sizefrom .top0 ""
  wm geometry .top0 +238+24
  wm maxsize .top0 1000 900
  wm minsize .top0 240 188
  wm title .top0 {Place Parameters}


  # build widget .top0.frame
  frame .top0.frame \
    -background {SkyBlue1}\
    -relief {raised}

  # build widget .top0.frame.frame
  frame .top0.frame.frame \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top0.frame.frame.frame
  frame .top0.frame.frame.frame \
    -background {SkyBlue1}\
    -relief {raised}

  # build widget .top0.frame.frame.frame.scrollbar1
  scrollbar .top0.frame.frame.frame.scrollbar1 \
    -activeforeground {SteelBlue3}\
    -background {SkyBlue1}\
    -command {.top0.frame.frame.frame.text2 yview}\
    -foreground {SteelBlue2}\
    -width {14}

  # build widget .top0.frame.frame.frame.text2
  text .top0.frame.frame.frame.text2 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -font {8x13}\
    -height {4}\
    -relief {raised}\
    -selectforeground {black}\
    -width {40}\
    -wrap {none}\
    -yscrollcommand {.top0.frame.frame.frame.scrollbar1 set}

  # pack widget .top0.frame.frame.frame
  pack append .top0.frame.frame.frame \
    .top0.frame.frame.frame.scrollbar1 {left frame center filly} \
    .top0.frame.frame.frame.text2 {top frame center expand fill} 

  # build widget .top0.frame.frame.label4
  label .top0.frame.frame.label4 \
    -background {SkyBlue1}\
    -font {8x13}\
    -padx {2}\
    -text {Label text:}

  # pack widget .top0.frame.frame
  pack append .top0.frame.frame \
    .top0.frame.frame.label4 {top frame w} \
    .top0.frame.frame.frame {top frame center expand fill} 

  # build widget .top0.frame.frame2
  frame .top0.frame.frame2 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top0.frame.frame2.frame5
  frame .top0.frame.frame2.frame5 \
    -background {SkyBlue1}

  # build widget .top0.frame.frame2.frame5.radiobutton10
  radiobutton .top0.frame.frame2.frame5.radiobutton10 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {SW}\
    -value {-1 1}\
    -variable {place_panel_label_offset}

  # build widget .top0.frame.frame2.frame5.radiobutton8
  radiobutton .top0.frame.frame2.frame5.radiobutton8 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {NW}\
    -value {-1 -1}\
    -variable {place_panel_label_offset}

  # build widget .top0.frame.frame2.frame5.radiobutton9
  radiobutton .top0.frame.frame2.frame5.radiobutton9 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text { W}\
    -value {-1 0}\
    -variable {place_panel_label_offset}

  # pack widget .top0.frame.frame2.frame5
  pack append .top0.frame.frame2.frame5 \
    .top0.frame.frame2.frame5.radiobutton8 {top frame center} \
    .top0.frame.frame2.frame5.radiobutton9 {top frame w expand fillx} \
    .top0.frame.frame2.frame5.radiobutton10 {top frame center} 

  # build widget .top0.frame.frame2.frame6
  frame .top0.frame.frame2.frame6 \
    -background {SkyBlue1}

  # build widget .top0.frame.frame2.frame6.label15
  label .top0.frame.frame2.frame6.label15 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {}

  # build widget .top0.frame.frame2.frame6.radiobutton14
  radiobutton .top0.frame.frame2.frame6.radiobutton14 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {N }\
    -value {0 -1}\
    -variable {place_panel_label_offset}

  # build widget .top0.frame.frame2.frame6.radiobutton16
  radiobutton .top0.frame.frame2.frame6.radiobutton16 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {S }\
    -value {0 1}\
    -variable {place_panel_label_offset}

  # pack widget .top0.frame.frame2.frame6
  pack append .top0.frame.frame2.frame6 \
    .top0.frame.frame2.frame6.radiobutton14 {top frame center fillx} \
    .top0.frame.frame2.frame6.label15 {top frame center fillx} \
    .top0.frame.frame2.frame6.radiobutton16 {top frame center fillx} 

  # build widget .top0.frame.frame2.frame7
  frame .top0.frame.frame2.frame7 \
    -background {SkyBlue1}

  # build widget .top0.frame.frame2.frame7.radiobutton11
  radiobutton .top0.frame.frame2.frame7.radiobutton11 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {NE}\
    -value {1 -1}\
    -variable {place_panel_label_offset}

  # build widget .top0.frame.frame2.frame7.radiobutton12
  radiobutton .top0.frame.frame2.frame7.radiobutton12 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text { E}\
    -value {1 0}\
    -variable {place_panel_label_offset}

  # build widget .top0.frame.frame2.frame7.radiobutton13
  radiobutton .top0.frame.frame2.frame7.radiobutton13 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {SE}\
    -value {1 1}\
    -variable {place_panel_label_offset}

  # pack widget .top0.frame.frame2.frame7
  pack append .top0.frame.frame2.frame7 \
    .top0.frame.frame2.frame7.radiobutton11 {top frame center expand fillx} \
    .top0.frame.frame2.frame7.radiobutton12 {top frame center expand fillx} \
    .top0.frame.frame2.frame7.radiobutton13 {top frame center expand fillx} 

  # build widget .top0.frame.frame2.label4
  label .top0.frame.frame2.label4 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Label at:}

  # pack widget .top0.frame.frame2
  pack append .top0.frame.frame2 \
    .top0.frame.frame2.label4 {top frame nw} \
    .top0.frame.frame2.frame5 {left frame center} \
    .top0.frame.frame2.frame6 {left frame center expand fillx} \
    .top0.frame.frame2.frame7 {left frame center} 

  # build widget .top0.frame.frame20
  frame .top0.frame.frame20 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .top0.frame.frame20.button22
  button .top0.frame.frame20.button22 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {wm withdraw $symbolicName(place_panel)}\
    -font {8x13}\
    -text {Cancel}

  # build widget .top0.frame.frame20.button23
  button .top0.frame.frame20.button23 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {panelProcess place
wm withdraw $symbolicName(place_panel)}\
    -font {8x13}\
    -text {Apply}

  # pack widget .top0.frame.frame20
  pack append .top0.frame.frame20 \
    .top0.frame.frame20.button22 {left frame center} \
    .top0.frame.frame20.button23 {right frame center} 

  # build widget .top0.frame.frame3
  frame .top0.frame.frame3 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .top0.frame.frame3.scale21
  scale .top0.frame.frame3.scale21 \
    -activeforeground {SteelBlue2}\
    -background {SkyBlue1}\
    -command {set place_panel_marking}\
    -font {8x13}\
    -label {Marking:}\
    -length {0}\
    -orient {horizontal}\
    -relief {raised}\
    -sliderforeground {SkyBlue1}\
    -sliderlength {16}\
    -to {99}\
    -width {10}

  # build widget .top0.frame.frame3.scale4
  scale .top0.frame.frame3.scale4 \
    -activeforeground {SteelBlue2}\
    -background {SkyBlue1}\
    -command {set place_panel_min_tokens}\
    -font {8x13}\
    -label {Min Tokens:}\
    -length {0}\
    -orient {horizontal}\
    -relief {raised}\
    -sliderforeground {SkyBlue1}\
    -sliderlength {16}\
    -to {99}\
    -width {10}

  # build widget .top0.frame.frame3.scale5
  scale .top0.frame.frame3.scale5 \
    -activeforeground {SteelBlue2}\
    -background {SkyBlue1}\
    -command {set place_panel_max_tokens}\
    -font {8x13}\
    -label {Max Tokens:}\
    -length {0}\
    -orient {horizontal}\
    -relief {raised}\
    -sliderforeground {SkyBlue1}\
    -sliderlength {16}\
    -to {99}\
    -width {10}

  # pack widget .top0.frame.frame3
  pack append .top0.frame.frame3 \
    .top0.frame.frame3.scale21 {left frame w expand fillx} \
    .top0.frame.frame3.scale4 {left frame center expand fillx} \
    .top0.frame.frame3.scale5 {left frame center expand fillx} 

  # pack widget .top0.frame
  pack append .top0.frame \
    .top0.frame.frame20 {bottom frame w fillx} \
    .top0.frame.frame3 {bottom frame center expand fillx} \
    .top0.frame.frame2 {right frame w} \
    .top0.frame.frame {left frame center pady 2 filly} 

  # build widget .top0.label1
  label .top0.label1 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {Place Parameters}

  # pack widget .top0
  pack append .top0 \
    .top0.label1 {top frame center fillx} \
    .top0.frame {bottom frame center expand fill} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top0
  }

  .top0.frame.frame.frame.text2 insert end {}


}

proc DestroyWindow.top0 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top0]" != ""} {
      global xfShowWindow.top0
      set xfShowWindow.top0 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top0; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top0"
    update
  }
}


# procedure to show window .top1
proc ShowWindow.top1 {args} {# xf ignore me 7

  # build widget .top1
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top1"
  } {
    catch "destroy .top1"
  }
  toplevel .top1 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # Window manager configurations
  global tkVersion
  wm positionfrom .top1 user
  wm sizefrom .top1 ""
  wm geometry .top1 +289+105
  wm maxsize .top1 1000 900
  wm minsize .top1 240 239
  wm title .top1 {Transition Parameters}


  # build widget .top1.frame
  frame .top1.frame \
    -background {SkyBlue1}

  # build widget .top1.frame.frame
  frame .top1.frame.frame \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top1.frame.frame.frame
  frame .top1.frame.frame.frame \
    -background {SkyBlue1}\
    -relief {raised}

  # build widget .top1.frame.frame.frame.scrollbar1
  scrollbar .top1.frame.frame.frame.scrollbar1 \
    -activeforeground {SteelBlue3}\
    -background {SkyBlue1}\
    -command {.top1.frame.frame.frame.text2 yview}\
    -foreground {SteelBlue2}\
    -width {14}

  # build widget .top1.frame.frame.frame.text2
  text .top1.frame.frame.frame.text2 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -font {8x13}\
    -height {4}\
    -relief {sunken}\
    -selectforeground {black}\
    -width {40}\
    -wrap {none}\
    -yscrollcommand {.top1.frame.frame.frame.scrollbar1 set}

  # pack widget .top1.frame.frame.frame
  pack append .top1.frame.frame.frame \
    .top1.frame.frame.frame.scrollbar1 {left frame center filly} \
    .top1.frame.frame.frame.text2 {top frame center expand fill} 

  # build widget .top1.frame.frame.label4
  label .top1.frame.frame.label4 \
    -background {SkyBlue1}\
    -font {8x13}\
    -padx {2}\
    -text {Label text:}

  # pack widget .top1.frame.frame
  pack append .top1.frame.frame \
    .top1.frame.frame.label4 {top frame w} \
    .top1.frame.frame.frame {top frame center expand fill} 

  # build widget .top1.frame.frame13
  frame .top1.frame.frame13 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top1.frame.frame13.frame15
  frame .top1.frame.frame13.frame15 \
    -background {SkyBlue1}

  # build widget .top1.frame.frame13.frame15.label24
  label .top1.frame.frame13.frame15.label24 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Fire at will}

  # build widget .top1.frame.frame13.frame15.radiobutton18
  radiobutton .top1.frame.frame13.frame15.radiobutton18 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/trans.bm}\
    -font {8x13}\
    -text {Fire at will}\
    -value {fire}\
    -variable {trans_panel_inhibit}

  # pack widget .top1.frame.frame13.frame15
  pack append .top1.frame.frame13.frame15 \
    .top1.frame.frame13.frame15.radiobutton18 {left frame center} \
    .top1.frame.frame13.frame15.label24 {left frame center} 

  # build widget .top1.frame.frame13.frame16
  frame .top1.frame.frame13.frame16 \
    -background {SkyBlue1}

  # build widget .top1.frame.frame13.frame16.label21
  label .top1.frame.frame13.frame16.label21 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Hold your fire}

  # build widget .top1.frame.frame13.frame16.radiobutton20
  radiobutton .top1.frame.frame13.frame16.radiobutton20 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/transHold.bm}\
    -font {8x13}\
    -text {Hold your fire}\
    -value {hold}\
    -variable {trans_panel_inhibit}

  # pack widget .top1.frame.frame13.frame16
  pack append .top1.frame.frame13.frame16 \
    .top1.frame.frame13.frame16.radiobutton20 {left frame center} \
    .top1.frame.frame13.frame16.label21 {left frame center} 

  # build widget .top1.frame.frame13.frame17
  frame .top1.frame.frame13.frame17 \
    -background {SkyBlue1}

  # build widget .top1.frame.frame13.frame17.label23
  label .top1.frame.frame13.frame17.label23 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Cease fire}

  # build widget .top1.frame.frame13.frame17.radiobutton22
  radiobutton .top1.frame.frame13.frame17.radiobutton22 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/transInhibit.bm}\
    -font {8x13}\
    -text {Cease fire}\
    -value {inhibit}\
    -variable {trans_panel_inhibit}

  # pack widget .top1.frame.frame13.frame17
  pack append .top1.frame.frame13.frame17 \
    .top1.frame.frame13.frame17.radiobutton22 {left frame center} \
    .top1.frame.frame13.frame17.label23 {left frame center} 

  # build widget .top1.frame.frame13.label1
  label .top1.frame.frame13.label1 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Firing Status:  }

  # build widget .top1.frame.frame13.label14
  label .top1.frame.frame13.label14 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {not enabled}\
    -textvariable {trans_panel_fire_status}

  # pack widget .top1.frame.frame13
  pack append .top1.frame.frame13 \
    .top1.frame.frame13.frame17 {bottom frame w} \
    .top1.frame.frame13.frame16 {bottom frame w} \
    .top1.frame.frame13.frame15 {bottom frame w} \
    .top1.frame.frame13.label14 {right frame w} \
    .top1.frame.frame13.label1 {left frame center} 

  # build widget .top1.frame.frame2
  frame .top1.frame.frame2 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top1.frame.frame2.frame5
  frame .top1.frame.frame2.frame5 \
    -background {SkyBlue1}

  # build widget .top1.frame.frame2.frame5.radiobutton10
  radiobutton .top1.frame.frame2.frame5.radiobutton10 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {SW}\
    -value {-1 1}\
    -variable {trans_panel_label_offset}

  # build widget .top1.frame.frame2.frame5.radiobutton8
  radiobutton .top1.frame.frame2.frame5.radiobutton8 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {NW}\
    -value {-1 -1}\
    -variable {trans_panel_label_offset}

  # build widget .top1.frame.frame2.frame5.radiobutton9
  radiobutton .top1.frame.frame2.frame5.radiobutton9 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text { W}\
    -value {-1 0}\
    -variable {trans_panel_label_offset}

  # pack widget .top1.frame.frame2.frame5
  pack append .top1.frame.frame2.frame5 \
    .top1.frame.frame2.frame5.radiobutton8 {top frame center} \
    .top1.frame.frame2.frame5.radiobutton9 {top frame w expand fillx} \
    .top1.frame.frame2.frame5.radiobutton10 {top frame center} 

  # build widget .top1.frame.frame2.frame6
  frame .top1.frame.frame2.frame6 \
    -background {SkyBlue1}

  # build widget .top1.frame.frame2.frame6.label15
  label .top1.frame.frame2.frame6.label15 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {}

  # build widget .top1.frame.frame2.frame6.radiobutton14
  radiobutton .top1.frame.frame2.frame6.radiobutton14 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {N }\
    -value {0 -1}\
    -variable {trans_panel_label_offset}

  # build widget .top1.frame.frame2.frame6.radiobutton16
  radiobutton .top1.frame.frame2.frame6.radiobutton16 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {S }\
    -value {0 1}\
    -variable {trans_panel_label_offset}

  # pack widget .top1.frame.frame2.frame6
  pack append .top1.frame.frame2.frame6 \
    .top1.frame.frame2.frame6.radiobutton14 {top frame center fillx} \
    .top1.frame.frame2.frame6.label15 {top frame center fillx} \
    .top1.frame.frame2.frame6.radiobutton16 {top frame center fillx} 

  # build widget .top1.frame.frame2.frame7
  frame .top1.frame.frame2.frame7 \
    -background {SkyBlue1}

  # build widget .top1.frame.frame2.frame7.radiobutton11
  radiobutton .top1.frame.frame2.frame7.radiobutton11 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {NE}\
    -value {1 -1}\
    -variable {trans_panel_label_offset}

  # build widget .top1.frame.frame2.frame7.radiobutton12
  radiobutton .top1.frame.frame2.frame7.radiobutton12 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text { E}\
    -value {1 0}\
    -variable {trans_panel_label_offset}

  # build widget .top1.frame.frame2.frame7.radiobutton13
  radiobutton .top1.frame.frame2.frame7.radiobutton13 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -text {SE}\
    -value {1 1}\
    -variable {trans_panel_label_offset}

  # pack widget .top1.frame.frame2.frame7
  pack append .top1.frame.frame2.frame7 \
    .top1.frame.frame2.frame7.radiobutton11 {top frame center expand fillx} \
    .top1.frame.frame2.frame7.radiobutton12 {top frame center expand fillx} \
    .top1.frame.frame2.frame7.radiobutton13 {top frame center expand fillx} 

  # build widget .top1.frame.frame2.label4
  label .top1.frame.frame2.label4 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Label at:}

  # pack widget .top1.frame.frame2
  pack append .top1.frame.frame2 \
    .top1.frame.frame2.label4 {top frame nw} \
    .top1.frame.frame2.frame5 {left frame center} \
    .top1.frame.frame2.frame6 {left frame center expand fillx} \
    .top1.frame.frame2.frame7 {left frame center} 

  # build widget .top1.frame.frame20
  frame .top1.frame.frame20 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .top1.frame.frame20.button22
  button .top1.frame.frame20.button22 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {wm withdraw $symbolicName(trans_panel)}\
    -font {8x13}\
    -text {Cancel}

  # build widget .top1.frame.frame20.button23
  button .top1.frame.frame20.button23 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {panelProcess trans; wm withdraw $symbolicName(trans_panel)}\
    -font {8x13}\
    -text {Apply}

  # pack widget .top1.frame.frame20
  pack append .top1.frame.frame20 \
    .top1.frame.frame20.button22 {left frame center fillx} \
    .top1.frame.frame20.button23 {right frame center fillx} 

  # pack widget .top1.frame
  pack append .top1.frame \
    .top1.frame.frame20 {bottom frame w fillx} \
    .top1.frame.frame13 {bottom frame center pady 4} \
    .top1.frame.frame {left frame center pady 2 expand fill} \
    .top1.frame.frame2 {right frame w} 

  # build widget .top1.label3
  label .top1.label3 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {Transition Parameters}

  # pack widget .top1
  pack append .top1 \
    .top1.label3 {top frame center fillx} \
    .top1.frame {bottom frame center expand fill} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top1
  }

  .top1.frame.frame.frame.text2 insert end {}


}

proc DestroyWindow.top1 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top1]" != ""} {
      global xfShowWindow.top1
      set xfShowWindow.top1 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top1; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top1"
    update
  }
}


# procedure to show window .top2
proc ShowWindow.top2 {args} {# xf ignore me 7

  # build widget .top2
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top2"
  } {
    catch "destroy .top2"
  }
  toplevel .top2 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # Window manager configurations
  global tkVersion
  wm positionfrom .top2 user
  wm sizefrom .top2 ""
  wm geometry .top2 +703+103
  wm maxsize .top2 1000 900
  wm minsize .top2 192 146
  wm title .top2 {XPetri Parameters}


  # build widget .top2.frame
  frame .top2.frame \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top2.frame.entry5
  entry .top2.frame.entry5 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {sunken}\
    -selectforeground {black}\
    -textvariable {xpetri_panel_save_state_max}

  # build widget .top2.frame.label4
  label .top2.frame.label4 \
    -background {SkyBlue1}\
    -font {8x13}\
    -padx {2}\
    -text {History Max:}

  # pack widget .top2.frame
  pack append .top2.frame \
    .top2.frame.label4 {left frame center} \
    .top2.frame.entry5 {top frame center expand fill} 

  # build widget .top2.frame0
  frame .top2.frame0 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .top2.frame0.entry2
  entry .top2.frame0.entry2 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {sunken}\
    -selectforeground {black}\
    -textvariable {xpetri_panel_occurrence_max}\
    -width {0}

  # build widget .top2.frame0.label1
  label .top2.frame0.label1 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Analysis Max:}

  # pack widget .top2.frame0
  pack append .top2.frame0 \
    .top2.frame0.label1 {left frame center} \
    .top2.frame0.entry2 {right frame center expand fillx} 

  # build widget .top2.frame4
  frame .top2.frame4 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .top2.frame4.button5
  button .top2.frame4.button5 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {wm withdraw $symbolicName(xpetri_panel)}\
    -font {8x13}\
    -text {Cancel}

  # build widget .top2.frame4.button6
  button .top2.frame4.button6 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {panelProcess xpetri
wm withdraw $symbolicName(xpetri_panel)}\
    -font {8x13}\
    -text {Apply}

  # pack widget .top2.frame4
  pack append .top2.frame4 \
    .top2.frame4.button5 {left frame center} \
    .top2.frame4.button6 {right frame center} 

  # build widget .top2.label3
  label .top2.label3 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {XPetri Parameters}

  # build widget .top2.scale1
  scale .top2.scale1 \
    -activeforeground {SteelBlue2}\
    -background {SkyBlue1}\
    -font {8x13}\
    -from {1}\
    -label {Arc smoothness ->>}\
    -length {0}\
    -orient {horizontal}\
    -relief {raised}\
    -sliderforeground {SkyBlue1}\
    -sliderlength {16}\
    -to {32}\
    -width {10}

  # pack widget .top2
  pack append .top2 \
    .top2.label3 {top frame center fillx} \
    .top2.scale1 {top frame center expand fillx} \
    .top2.frame4 {bottom frame center fillx} \
    .top2.frame0 {top frame center fillx} \
    .top2.frame {top frame center fill} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top2
  }

  .top2.frame.entry5 insert end {}
  .top2.frame0.entry2 insert end {}


}

proc DestroyWindow.top2 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top2]" != ""} {
      global xfShowWindow.top2
      set xfShowWindow.top2 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top2; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top2"
    update
  }
}


# procedure to show window .top3
proc ShowWindow.top3 {args} {# xf ignore me 7

  # build widget .top3
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top3"
  } {
    catch "destroy .top3"
  }
  toplevel .top3 \
    -background {SkyBlue1}

  # Window manager configurations
  global tkVersion
  wm positionfrom .top3 ""
  wm sizefrom .top3 ""
  wm maxsize .top3 1000 900
  wm minsize .top3 10 10
  wm title .top3 {top3}


  # build widget .top3.button6
  button .top3.button6 \
    -activebackground {SkyBlue2}\
    -background {SkyBlue1}\
    -command {wm withdraw $symbolicName(help_panel)}\
    -font {8x13}\
    -text {Done}

  # build widget .top3.frame
  frame .top3.frame \
    -background {SkyBlue1}\
    -relief {raised}

  # build widget .top3.frame.scrollbar1
  scrollbar .top3.frame.scrollbar1 \
    -activeforeground {SteelBlue3}\
    -background {SkyBlue1}\
    -command {.top3.frame.text2 yview}\
    -foreground {SteelBlue2}\
    -relief {raised}

  # build widget .top3.frame.text2
  text .top3.frame.text2 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -font {8x13}\
    -relief {raised}\
    -wrap {none}\
    -yscrollcommand {.top3.frame.scrollbar1 set}
  # bindings
  bind .top3.frame.text2 <Any-Key> {NoFunction}

  # pack widget .top3.frame
  pack append .top3.frame \
    .top3.frame.scrollbar1 {left frame center filly} \
    .top3.frame.text2 {top frame center expand fill} 

  # build widget .top3.label8
  label .top3.label8 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {General Help}

  # pack widget .top3
  pack append .top3 \
    .top3.button6 {bottom frame center fillx} \
    .top3.label8 {top frame center fillx} \
    .top3.frame {top frame center expand fill} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top3
  }

  .top3.frame.text2 insert end {}


}

proc DestroyWindow.top3 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top3]" != ""} {
      global xfShowWindow.top3
      set xfShowWindow.top3 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top3; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top3"
    update
  }
}


# procedure to show window .top5
proc ShowWindow.top5 {args} {# xf ignore me 7

  # build widget .top5
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top5"
  } {
    catch "destroy .top5"
  }
  toplevel .top5 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {sunken}

  # Window manager configurations
  global tkVersion
  wm positionfrom .top5 user
  wm sizefrom .top5 user
  wm geometry .top5 +656+6
  wm maxsize .top5 1000 900
  wm minsize .top5 165 98
  wm title .top5 {Arc Parameters}


  # build widget .top5.frame
  frame .top5.frame \
    -background {SkyBlue1}

  # build widget .top5.frame.frame20
  frame .top5.frame.frame20 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .top5.frame.frame20.button22
  button .top5.frame.frame20.button22 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {wm withdraw $symbolicName(arc_panel)}\
    -font {8x13}\
    -text {Cancel}

  # build widget .top5.frame.frame20.button23
  button .top5.frame.frame20.button23 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {panelProcess arc
wm withdraw $symbolicName(arc_panel)}\
    -font {8x13}\
    -text {Apply}

  # pack widget .top5.frame.frame20
  pack append .top5.frame.frame20 \
    .top5.frame.frame20.button22 {left frame center} \
    .top5.frame.frame20.button23 {right frame center} 

  # build widget .top5.frame.scale21
  scale .top5.frame.scale21 \
    -activeforeground {SteelBlue2}\
    -background {SkyBlue1}\
    -command {set arc_panel_weight}\
    -font {8x13}\
    -label {Weight:}\
    -length {0}\
    -orient {horizontal}\
    -relief {raised}\
    -sliderforeground {SkyBlue1}\
    -sliderlength {16}\
    -to {99}\
    -width {10}

  # pack widget .top5.frame
  pack append .top5.frame \
    .top5.frame.scale21 {top frame center expand fillx} \
    .top5.frame.frame20 {bottom frame center pady 2 expand fillx} 

  # build widget .top5.label1
  label .top5.label1 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {raised}\
    -text {Arc Parameters}

  # pack widget .top5
  pack append .top5 \
    .top5.label1 {top frame center fillx} \
    .top5.frame {bottom frame center expand fill} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top5
  }
}

proc DestroyWindow.top5 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top5]" != ""} {
      global xfShowWindow.top5
      set xfShowWindow.top5 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top5; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top5"
    update
  }
}


# procedure to show window .
proc ShowWindow. {args} {# xf ignore me 7

  # Window manager configurations
  global tkVersion
  wm positionfrom . user
  wm sizefrom . user
  wm geometry . 384x442+0+0
  wm maxsize . 1152 900
  wm minsize . 350 332
  wm title . {xpetri.tcl}


  # build widget .frame0
  frame .frame0 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .frame0.frame0
  frame .frame0.frame0 \
    -background {SkyBlue1}\
    -relief {raised}

  # build widget .frame0.frame0.scrollbar1
  scrollbar .frame0.frame0.scrollbar1 \
    -activeforeground {SteelBlue3}\
    -background {SkyBlue1}\
    -command {.frame0.frame0.canvas2 yview}\
    -foreground {SteelBlue2}\
    -relief {raised}\
    -width {14}

  # build widget .frame0.frame0.scrollbar3
  scrollbar .frame0.frame0.scrollbar3 \
    -activeforeground {SteelBlue3}\
    -background {SkyBlue1}\
    -command {.frame0.frame0.canvas2 xview}\
    -foreground {SteelBlue2}\
    -orient {horizontal}\
    -relief {raised}\
    -width {14}

  # build widget .frame0.frame0.canvas2
  canvas .frame0.frame0.canvas2 \
    -background {LightSteelBlue1}\
    -height {207}\
    -insertofftime {600}\
    -relief {raised}\
    -scrollregion {0 0 22.5i 30i}\
    -selectforeground {black}\
    -width {295}\
    -xscrollcommand {.frame0.frame0.scrollbar3 set}\
    -yscrollcommand {.frame0.frame0.scrollbar1 set}
  # build canvas items .frame0.frame0.canvas2

  # pack widget .frame0.frame0
  pack append .frame0.frame0 \
    .frame0.frame0.scrollbar1 {left frame center filly} \
    .frame0.frame0.canvas2 {top frame center expand fill} \
    .frame0.frame0.scrollbar3 {top frame center fillx} 

  # build widget .frame0.frame1
  frame .frame0.frame1 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .frame0.frame1.menubutton1
  menubutton .frame0.frame1.menubutton1 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -menu {.frame0.frame1.menubutton1.m}\
    -text {Net}\
    -underline {0}

  # build widget .frame0.frame1.menubutton1.m
  menu .frame0.frame1.menubutton1.m \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}
  .frame0.frame1.menubutton1.m add command\
    -command {FSBox "Load Net" $filename fsbox_load }\
    -label {Open...}\
    -underline {0}
  .frame0.frame1.menubutton1.m add command\
    -command {netSave}\
    -label {Save}\
    -underline {0}
  .frame0.frame1.menubutton1.m add command\
    -command {FSBox "Save Net" "" fsbox_save}\
    -label {Save As...}\
    -underline {5}
  .frame0.frame1.menubutton1.m add command\
    -command {netPrint}\
    -label {Print}\
    -underline {0}
  .frame0.frame1.menubutton1.m add separator
  .frame0.frame1.menubutton1.m add command\
    -command {netPurge}\
    -label {Erase}\
    -underline {0}
  .frame0.frame1.menubutton1.m add separator
  .frame0.frame1.menubutton1.m add command\
    -command {netQuit}\
    -label {Quit}\
    -underline {0}

  # build widget .frame0.frame1.menubutton3
  menubutton .frame0.frame1.menubutton3 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -menu {.frame0.frame1.menubutton3.m}\
    -text {Analysis}\
    -underline {0}

  # build widget .frame0.frame1.menubutton3.m
  menu .frame0.frame1.menubutton3.m \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}
  .frame0.frame1.menubutton3.m add command\
    -command {graphInvariants s}\
    -label {S-invariant}\
    -state {active}\
    -underline {0}
  .frame0.frame1.menubutton3.m add command\
    -command {graphInvariants t}\
    -label {T-invariant}\
    -underline {0}
  .frame0.frame1.menubutton3.m add command\
    -command {graphReachable}\
    -label {Occurrence Graph}\
    -underline {0}
  .frame0.frame1.menubutton3.m add command\
    -command {graphCoverage}\
    -label {Coverage Graph}\
    -underline {0}

  # build widget .frame0.frame1.menubutton5
  menubutton .frame0.frame1.menubutton5 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -menu {.frame0.frame1.menubutton5.m}\
    -text {State}\
    -underline {0}

  # build widget .frame0.frame1.menubutton5.m
  menu .frame0.frame1.menubutton5.m \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}
  .frame0.frame1.menubutton5.m add command\
    -command {fire}\
    -label {Fire Net}\
    -underline {0}
  .frame0.frame1.menubutton5.m add separator
  .frame0.frame1.menubutton5.m add command\
    -command {stateNext}\
    -label {Next State}\
    -state {active}\
    -underline {0}
  .frame0.frame1.menubutton5.m add command\
    -command {statePrev}\
    -label {Previous State}\
    -underline {0}
  .frame0.frame1.menubutton5.m add separator
  .frame0.frame1.menubutton5.m add command\
    -command {stateInitial}\
    -label {Initial State}\
    -underline {0}
  .frame0.frame1.menubutton5.m add separator
  .frame0.frame1.menubutton5.m add command\
    -command {stateSetInitial}\
    -label {Set Inital State (0)}\
    -underline {18}
  .frame0.frame1.menubutton5.m add command\
    -command {stateOne}\
    -label {Set First State (1)}\
    -underline {17}
  .frame0.frame1.menubutton5.m add separator
  .frame0.frame1.menubutton5.m add command\
    -command {global state_current
statePurge [expr 1+$state_current]}\
    -label {Erase History}

  # build widget .frame0.frame1.menubutton7
  menubutton .frame0.frame1.menubutton7 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -menu {.frame0.frame1.menubutton7.m}\
    -text {Display}\
    -underline {0}

  # build widget .frame0.frame1.menubutton7.m
  menu .frame0.frame1.menubutton7.m \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {displayRefresh}\
    -label {Blocked}\
    -variable {displayBlockedTrans}\
    -underline {0}
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {displayRefresh}\
    -label {Conflict}\
    -variable {displayConflictPlace}\
    -underline {0}
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {displayRefresh}\
    -label {Difference}\
    -variable {displayDifference}\
    -underline {0}
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {displayRefresh}\
    -label {Enabled}\
    -variable {displayEnabledTrans}\
    -underline {0}
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {displayRefresh}\
    -label {Fired}\
    -variable {displayFiredArc}\
    -underline {0}
  .frame0.frame1.menubutton7.m add separator
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {labelRefresh}\
    -label {Place Labels}\
    -variable {label_display(place)}\
    -underline {0}
  .frame0.frame1.menubutton7.m add checkbutton\
    -command {labelRefresh}\
    -label {Trans Labels}\
    -variable {label_display(trans)}\
    -underline {0}

  # build widget .frame0.frame1.menubutton9
  menubutton .frame0.frame1.menubutton9 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -menu {.frame0.frame1.menubutton9.m}\
    -text {Options}\
    -underline {0}

  # build widget .frame0.frame1.menubutton9.m
  menu .frame0.frame1.menubutton9.m \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}
  .frame0.frame1.menubutton9.m add command\
    -command {panelPrepare xpetri
wm deiconify [SN xpetri_panel]}\
    -label {XPetri Parameters...}\
    -underline {0}
  .frame0.frame1.menubutton9.m add separator
  .frame0.frame1.menubutton9.m add checkbutton\
    -command {guiConflictMode $auto_conflict_mode}\
    -label {Resolve Conflicts}\
    -state {active}\
    -variable {auto_conflict_mode}\
    -underline {0}
  .frame0.frame1.menubutton9.m add separator
  .frame0.frame1.menubutton9.m add radiobutton\
    -command {modeNormal}\
    -label {Move and Copy Objects}\
    -value {Normal}\
    -variable {modeState}\
    -underline {0}
  .frame0.frame1.menubutton9.m add radiobutton\
    -command {modeAddObjects}\
    -label {Add Objects}\
    -value {AddObjects}\
    -variable {modeState}\
    -underline {0}
  .frame0.frame1.menubutton9.m add radiobutton\
    -command {modeModify}\
    -label {Change Object Parms}\
    -value {Modify}\
    -variable {modeState}\
    -underline {0}
  .frame0.frame1.menubutton9.m add radiobutton\
    -command {modeKill}\
    -label {Destroy Objects}\
    -value {Kill}\
    -variable {modeState}\
    -underline {0}

  # build widget .frame0.frame1.menubutton99
  menubutton .frame0.frame1.menubutton99 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}\
    -menu {.frame0.frame1.menubutton99.m}\
    -text {Help}\
    -underline {0}

  # build widget .frame0.frame1.menubutton99.m
  menu .frame0.frame1.menubutton99.m \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -font {8x13}
  .frame0.frame1.menubutton99.m add command\
    -command {wm deiconify $symbolicName(help_panel)}\
    -label {General Help}\
    -state {active}\
    -underline {8}

  # pack widget .frame0.frame1
  pack append .frame0.frame1 \
    .frame0.frame1.menubutton1 {left frame center padx 4} \
    .frame0.frame1.menubutton3 {left frame center padx 4} \
    .frame0.frame1.menubutton5 {left frame center padx 4} \
    .frame0.frame1.menubutton7 {left frame center padx 4} \
    .frame0.frame1.menubutton9 {left frame center} \
    .frame0.frame1.menubutton99 {right frame center} 

  # build widget .frame0.frame2
  frame .frame0.frame2 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .frame0.frame2.button3
  button .frame0.frame2.button3 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {stateInitial}\
    -font {8x13}\
    -text {Init}

  # build widget .frame0.frame2.button8
  button .frame0.frame2.button8 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {fire}\
    -font {8x13}\
    -text {Fire}

  # build widget .frame0.frame2.button9
  button .frame0.frame2.button9 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -command {netSave}\
    -font {8x13}\
    -text {Save}

  # build widget .frame0.frame2.frame1
  frame .frame0.frame2.frame1 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .frame0.frame2.frame1.label0
  label .frame0.frame2.frame1.label0 \
    -background {SkyBlue1}\
    -borderwidth {0}\
    -font {8x13}\
    -text {=>}

  # build widget .frame0.frame2.frame1.label1
  label .frame0.frame2.frame1.label1 \
    -background {SkyBlue1}\
    -borderwidth {0}\
    -font {8x13}\
    -text {}\
    -textvariable {state_scale_to}

  # build widget .frame0.frame2.frame1.label2
  label .frame0.frame2.frame1.label2 \
    -background {SkyBlue1}\
    -borderwidth {0}\
    -font {8x13}\
    -text {State}

  # build widget .frame0.frame2.frame1.scale3
  scale .frame0.frame2.frame1.scale3 \
    -activeforeground {SteelBlue2}\
    -background {SkyBlue1}\
    -command {stateSelect}\
    -font {8x13}\
    -relief {raised}\
    -sliderforeground {SkyBlue1}\
    -sliderlength {16}\
    -to {99}\
    -width {10}

  # pack widget .frame0.frame2.frame1
  pack append .frame0.frame2.frame1 \
    .frame0.frame2.frame1.label2 {top frame center} \
    .frame0.frame2.frame1.scale3 {top frame center fillx} \
    .frame0.frame2.frame1.label0 {left frame center} \
    .frame0.frame2.frame1.label1 {right frame center} 

  # build widget .frame0.frame2.frame13
  frame .frame0.frame2.frame13 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .frame0.frame2.frame13.button1
  button .frame0.frame2.frame13.button1 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/modify.bm}\
    -command {modeModify}\
    -font {8x13}\
    -text {button1}

  # build widget .frame0.frame2.frame13.button14
  button .frame0.frame2.frame13.button14 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/left_ptr.bm}\
    -command {modeNormal}\
    -font {8x13}\
    -text {button14}

  # build widget .frame0.frame2.frame13.button15
  button .frame0.frame2.frame13.button15 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/objects.bm}\
    -command {modeAddObjects}\
    -font {8x13}\
    -text {button15}

  # build widget .frame0.frame2.frame13.button16
  button .frame0.frame2.frame13.button16 \
    -activebackground {SkyBlue2}\
    -activeforeground {black}\
    -background {SkyBlue1}\
    -bitmap {@bitmap/begone.bm}\
    -command {modeKill}\
    -font {8x13}\
    -text {button16}

  # pack widget .frame0.frame2.frame13
  pack append .frame0.frame2.frame13 \
    .frame0.frame2.frame13.button14 {top frame center fillx} \
    .frame0.frame2.frame13.button15 {top frame center} \
    .frame0.frame2.frame13.button1 {top frame center fillx} \
    .frame0.frame2.frame13.button16 {top frame center pady 8} 

  # pack widget .frame0.frame2
  pack append .frame0.frame2 \
    .frame0.frame2.frame13 {top frame center} \
    .frame0.frame2.button9 {bottom frame w pady 12 fillx} \
    .frame0.frame2.button3 {bottom frame center fillx} \
    .frame0.frame2.button8 {bottom frame w pady 12 fillx} \
    .frame0.frame2.frame1 {bottom frame center} 

  # build widget .frame0.frame4
  frame .frame0.frame4 \
    -background {SkyBlue1}\
    -borderwidth {2}\
    -relief {raised}

  # build widget .frame0.frame4.label6
  label .frame0.frame4.label6 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {}\
    -textvariable {statusMessage}

  # build widget .frame0.frame4.label7
  label .frame0.frame4.label7 \
    -background {SkyBlue1}\
    -borderwidth {1}\
    -font {8x13}\
    -text {}\
    -textvariable {warningMessage}

  # pack widget .frame0.frame4
  pack append .frame0.frame4 \
    .frame0.frame4.label6 {left frame center expand fillx} \
    .frame0.frame4.label7 {right frame center} 

  # build widget .frame0.frame5
  frame .frame0.frame5 \
    -background {SkyBlue1}\
    -borderwidth {2}

  # build widget .frame0.frame5.entry6
  entry .frame0.frame5.entry6 \
    -background {SkyBlue1}\
    -font {8x13}\
    -relief {sunken}\
    -selectforeground {black}\
    -textvariable {filename}
  # bindings
  bind .frame0.frame5.entry6 <Key-Return> {netLoad}
  bind .frame0.frame5.entry6 <Leave> {focus .}
  bind .frame0.frame5.entry6 <Enter> {focus %W}

  # build widget .frame0.frame5.label0
  label .frame0.frame5.label0 \
    -background {SkyBlue1}\
    -font {8x13}\
    -text {Name: }

  # build widget .frame0.frame5.label1
  label .frame0.frame5.label1 \
    -background {SkyBlue1}\
    -borderwidth {1}\
    -font {8x13}\
    -relief {raised}\
    -text {}\
    -textvariable {modeMessage}\
    -width {16}

  # pack widget .frame0.frame5
  pack append .frame0.frame5 \
    .frame0.frame5.label0 {left frame center fillx} \
    .frame0.frame5.entry6 {left frame center expand fillx} \
    .frame0.frame5.label1 {left frame center fillx} 

  # pack widget .frame0
  pack append .frame0 \
    .frame0.frame1 {top frame center fillx} \
    .frame0.frame4 {top frame center fillx} \
    .frame0.frame5 {top frame center fillx} \
    .frame0.frame2 {right frame center filly} \
    .frame0.frame0 {left frame center expand fill} 

  # pack widget .
  pack append . \
    .frame0 {top frame center expand fill} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .xfEdit
  }

  global tkVersion
  if {$tkVersion >= 3.0} {
    tk_menuBar .frame0.frame1 .frame0.frame1.menubutton1 .frame0.frame1.menubutton3 .frame0.frame1.menubutton5 .frame0.frame1.menubutton7 .frame0.frame1.menubutton9 .frame0.frame1.menubutton99
  } {
    tk_menus . .frame0.frame1.menubutton1 .frame0.frame1.menubutton3 .frame0.frame1.menubutton5 .frame0.frame1.menubutton7 .frame0.frame1.menubutton9 .frame0.frame1.menubutton99
  }

  .frame0.frame5.entry6 insert end {}


}


# User defined procedures


# Procedure: FSBox
proc FSBox { {fsBoxMessage "Select file:"} {fsBoxFileName ""} {fsBoxActionOk ""} {fsBoxActionCancel ""}} {
# xf ignore me 5
##########
# Procedure: FSBox
# Description: show file selector box
# Arguments: fsBoxMessage - the text to display
#            fsBoxFileName - a file name that should be selected
#            fsBoxActionOk - the action that should be performed on ok
#            fsBoxActionCancel - the action that should be performed on cancel
# Returns: the filename that was selected, or nothing
# Sideeffects: none
##########
# 
# global fsBox(activeBackground) - active background color
# global fsBox(activeForeground) - active foreground color
# global fsBox(background) - background color
# global fsBox(font) - text font
# global fsBox(foreground) - foreground color
# global fsBox(extensions) - scan directory for extensions
# global fsBox(scrollActiveForeground) - scrollbar active background color
# global fsBox(scrollBackground) - scrollbar background color
# global fsBox(scrollForeground) - scrollbar foreground color
# global fsBox(scrollSide) - side where scrollbar is located

  global fsBox

  set tmpButtonOpt ""
  set tmpFrameOpt ""
  set tmpMessageOpt ""
  set tmpScaleOpt ""
  set tmpScrollOpt ""
  if {"$fsBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$fsBox(activeBackground)\" "
  }
  if {"$fsBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$fsBox(activeForeground)\" "
  }
  if {"$fsBox(background)" != ""} {
    append tmpButtonOpt "-background \"$fsBox(background)\" "
    append tmpFrameOpt "-background \"$fsBox(background)\" "
    append tmpMessageOpt "-background \"$fsBox(background)\" "
  }
  if {"$fsBox(font)" != ""} {
    append tmpButtonOpt "-font \"$fsBox(font)\" "
    append tmpMessageOpt "-font \"$fsBox(font)\" "
  }
  if {"$fsBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$fsBox(foreground)\" "
    append tmpMessageOpt "-foreground \"$fsBox(foreground)\" "
  }
  if {"$fsBox(scrollActiveForeground)" != ""} {
    append tmpScrollOpt "-activeforeground \"$fsBox(scrollActiveForeground)\" "
  }
  if {"$fsBox(scrollBackground)" != ""} {
    append tmpScrollOpt "-background \"$fsBox(scrollBackground)\" "
  }
  if {"$fsBox(scrollForeground)" != ""} {
    append tmpScrollOpt "-foreground \"$fsBox(scrollForeground)\" "
  }

  if {[file exists [file tail $fsBoxFileName]] &&
      [IsAFile [file tail $fsBoxFileName]]} {
    set fsBox(name) [file tail $fsBoxFileName]
  } {
    set fsBox(name) ""
  }
  if {[file exists $fsBoxFileName] && [IsADir $fsBoxFileName]} {
    set fsBox(path) $fsBoxFileName
  } {
    if {"[file rootname $fsBoxFileName]" != "."} {
      set fsBox(path) [file rootname $fsBoxFileName]
    }
  }
  if {$fsBox(showPixmap)} {
    set fsBox(path) [string trimleft $fsBox(path) @]
  }
  if {"$fsBox(path)" != "" && [file exists $fsBox(path)] &&
      [IsADir $fsBox(path)]} {
    set fsBox(internalPath) $fsBox(path)
  } {
    if {"$fsBox(internalPath)" == "" ||
        ![file exists $fsBox(internalPath)]} {
      set fsBox(internalPath) [pwd]
    }
  }
  # build widget structure

  # start build of toplevel
  if {"[info commands XFDestroy]" != ""} {
    catch {XFDestroy .fsBox}
  } {
    catch {destroy .fsBox}
  }
  toplevel .fsBox     -borderwidth 0
  catch ".fsBox config $tmpFrameOpt"
  wm geometry .fsBox 350x300 
  wm title .fsBox {File select box}
  wm maxsize .fsBox 1000 1000
  wm minsize .fsBox 100 100
  # end build of toplevel

  label .fsBox.message1     -anchor c     -relief raised     -text "$fsBoxMessage"
  catch ".fsBox.message1 config $tmpMessageOpt"

  frame .fsBox.frame1     -borderwidth 0     -relief raised
  catch ".fsBox.frame1 config $tmpFrameOpt"

  button .fsBox.frame1.ok     -text "OK"     -command "
      global fsBox
      set fsBox(name) \[.fsBox.file.file get\]
      if {$fsBox(showPixmap)} {
        set fsBox(path) @\[.fsBox.path.path get\]
      } {
        set fsBox(path) \[.fsBox.path.path get\]
      }
      set fsBox(internalPath) \[.fsBox.path.path get\]
      $fsBoxActionOk
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .fsBox}
      } {
        catch {destroy .fsBox}
      }"
  catch ".fsBox.frame1.ok config $tmpButtonOpt"

  button .fsBox.frame1.rescan     -text "Rescan"     -command {
      global fsBox
      FSBoxFSShow [.fsBox.path.path get]         [.fsBox.pattern.pattern get] $fsBox(all)}
  catch ".fsBox.frame1.rescan config $tmpButtonOpt"

  button .fsBox.frame1.cancel     -text "Cancel"     -command "
      global fsBox
      set fsBox(name) {}
      set fsBox(path) {}
      $fsBoxActionCancel
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .fsBox}
      } {
        catch {destroy .fsBox}
      }"
  catch ".fsBox.frame1.cancel config $tmpButtonOpt"

  if {$fsBox(showPixmap)} {
    frame .fsBox.frame2       -borderwidth 0       -relief raised
    catch ".fsBox.frame2 config $tmpFrameOpt"

    scrollbar .fsBox.frame2.scrollbar3       -command {.fsBox.frame2.canvas2 xview}       -orient {horizontal}       -relief {raised}
    catch ".fsBox.frame2.scrollbar3 config $tmpScrollOpt"

    scrollbar .fsBox.frame2.scrollbar1       -command {.fsBox.frame2.canvas2 yview}       -relief {raised}
    catch ".fsBox.frame2.scrollbar1 config $tmpScrollOpt"

    canvas .fsBox.frame2.canvas2       -confine {true}       -relief {raised}       -scrollregion {0c 0c 20c 20c}       -width {100}       -xscrollcommand {.fsBox.frame2.scrollbar3 set}       -yscrollcommand {.fsBox.frame2.scrollbar1 set}
    catch ".fsBox.frame2.canvas2 config $tmpFrameOpt"

    .fsBox.frame2.canvas2 addtag currentBitmap withtag [.fsBox.frame2.canvas2 create bitmap 5 5 -anchor nw]
  }

  frame .fsBox.path     -borderwidth 0     -relief raised
  catch ".fsBox.path config $tmpFrameOpt"

  frame .fsBox.path.paths     -borderwidth 2     -relief raised
  catch ".fsBox.path.paths config $tmpFrameOpt"

  menubutton .fsBox.path.paths.paths     -borderwidth 0     -menu ".fsBox.path.paths.paths.menu"     -relief flat     -text "Pathname:"
  catch ".fsBox.path.paths.paths config $tmpButtonOpt"

  menu .fsBox.path.paths.paths.menu
  catch ".fsBox.path.paths.paths.menu config $tmpButtonOpt"

  .fsBox.path.paths.paths.menu add command      -label "[string trimright $fsBox(internalPath) {/@}]"      -command "
       global fsBox
       FSBoxFSShow \[.fsBox.path.path get\]          \[.fsBox.pattern.pattern get\] \$fsBox(all)
       .fsBox.path.path delete 0 end
       .fsBox.path.path insert 0 [string trimright $fsBox(internalPath) {/@}]"

  entry .fsBox.path.path     -relief raised
  catch ".fsBox.path.path config $tmpMessageOpt"

  if {![IsADir $fsBox(internalPath)]} {
    set $fsBox(internalPath) [pwd]
  }
  .fsBox.path.path insert 0 $fsBox(internalPath)

  frame .fsBox.pattern     -borderwidth 0     -relief raised
  catch ".fsBox.pattern config $tmpFrameOpt"

  frame .fsBox.pattern.patterns     -borderwidth 2     -relief raised
  catch ".fsBox.pattern.patterns config $tmpFrameOpt"

  menubutton .fsBox.pattern.patterns.patterns     -borderwidth 0     -menu ".fsBox.pattern.patterns.patterns.menu"     -relief flat     -text "Selection pattern:"
  catch ".fsBox.pattern.patterns.patterns config $tmpButtonOpt"

  menu .fsBox.pattern.patterns.patterns.menu
  catch ".fsBox.pattern.patterns.patterns.menu config $tmpButtonOpt"

  .fsBox.pattern.patterns.patterns.menu add checkbutton     -label "Scan extensions"     -variable fsBoxExtensions     -command {
      global fsBox
      FSBoxFSShow [.fsBox.path.path get]         [.fsBox.pattern.pattern get] $fsBox(all)}

  entry .fsBox.pattern.pattern     -relief raised
  catch ".fsBox.pattern.pattern config $tmpMessageOpt"

  .fsBox.pattern.pattern insert 0 $fsBox(pattern)
  
  frame .fsBox.files     -borderwidth 0     -relief raised
  catch ".fsBox.files config $tmpFrameOpt"

  scrollbar .fsBox.files.vscroll     -relief raised     -command ".fsBox.files.files yview"
  catch ".fsBox.files.vscroll config $tmpScrollOpt"

  scrollbar .fsBox.files.hscroll     -orient horiz     -relief raised     -command ".fsBox.files.files xview"
  catch ".fsBox.files.hscroll config $tmpScrollOpt"

  listbox .fsBox.files.files     -exportselection false     -relief raised     -xscrollcommand ".fsBox.files.hscroll set"     -yscrollcommand ".fsBox.files.vscroll set"
  catch ".fsBox.files.files config $tmpMessageOpt"

  frame .fsBox.file     -borderwidth 0     -relief raised
  catch ".fsBox.file config $tmpFrameOpt"

  label .fsBox.file.labelfile     -relief raised     -text "Filename:"
  catch ".fsBox.file.labelfile config $tmpMessageOpt"

  entry .fsBox.file.file     -relief raised
  catch ".fsBox.file.file config $tmpMessageOpt"

  .fsBox.file.file delete 0 end
  .fsBox.file.file insert 0 $fsBox(name)
  
  checkbutton .fsBox.pattern.all     -offvalue 0     -onvalue 1     -text "Show all files"     -variable fsBox(all)     -command {
      global fsBox
      FSBoxFSShow [.fsBox.path.path get]         [.fsBox.pattern.pattern get] $fsBox(all)}
  catch ".fsBox.pattern.all config $tmpButtonOpt"

  FSBoxFSShow $fsBox(internalPath) $fsBox(pattern) $fsBox(all)

  # bindings
  bind .fsBox.files.files <Double-Button-1> "
    FSBoxFSFileSelectDouble %W $fsBox(showPixmap) \{$fsBoxActionOk\} %y"
  bind .fsBox.files.files <ButtonPress-1> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"
  bind .fsBox.files.files <Button1-Motion> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"
  bind .fsBox.files.files <Shift-Button1-Motion> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"
  bind .fsBox.files.files <Shift-ButtonPress-1> "
    FSBoxFSFileSelect %W $fsBox(showPixmap) %y"

  bind .fsBox.path.path <Tab> {
    FSBoxFSNameComplete path}
  bind .fsBox.path.path <Return> {
    global tkVersion
    global fsBox
    FSBoxFSShow [.fsBox.path.path get]       [.fsBox.pattern.pattern get] $fsBox(all)
    FSBoxFSInsertPath
    if {$tkVersion >= 3.0} {
      .fsBox.file.file icursor end
    } {
      .fsBox.file.file cursor end
    }
    focus .fsBox.file.file}
  catch "bind .fsBox.path.path <Up> {}"
  bind .fsBox.path.path <Down> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.file.file icursor end
    } {
      .fsBox.file.file cursor end
    }
    focus .fsBox.file.file}

  bind .fsBox.file.file <Tab> {
    FSBoxFSNameComplete file}
  bind .fsBox.file.file <Return> "
    global fsBox
    set fsBox(name) \[.fsBox.file.file get\]
    if {$fsBox(showPixmap)} {
      set fsBox(path) @\[.fsBox.path.path get\]
    } {
      set fsBox(path) \[.fsBox.path.path get\]
    }
    set fsBox(internalPath) \[.fsBox.path.path get\]
    $fsBoxActionOk
    if {\"\[info commands XFDestroy\]\" != \"\"} {
      catch {XFDestroy .fsBox}
    } {
      catch {destroy .fsBox}
    }"
  bind .fsBox.file.file <Up> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.path.path icursor end
    } {
      .fsBox.path.path cursor end
    }
    focus .fsBox.path.path}
  bind .fsBox.file.file <Down> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.pattern.pattern icursor end
    } {
      .fsBox.pattern.pattern cursor end
    }
    focus .fsBox.pattern.pattern}

  bind .fsBox.pattern.pattern <Return> {
    global fsBox
    FSBoxFSShow [.fsBox.path.path get]       [.fsBox.pattern.pattern get] $fsBox(all)}
  bind .fsBox.pattern.pattern <Up> {
    global tkVersion
    if {$tkVersion >= 3.0} {
      .fsBox.file.file icursor end
    } {
      .fsBox.file.file cursor end
    }
    focus .fsBox.file.file}
  catch "bind .fsBox.pattern.pattern <Down> {}"

  # packing
  pack append .fsBox.files               .fsBox.files.vscroll "$fsBox(scrollSide) filly"               .fsBox.files.hscroll {bottom fillx}               .fsBox.files.files {left fill expand}
  pack append .fsBox.file               .fsBox.file.labelfile {left}               .fsBox.file.file {left fill expand}
  pack append .fsBox.frame1               .fsBox.frame1.ok {left fill expand}               .fsBox.frame1.rescan {left fill expand}               .fsBox.frame1.cancel {left fill expand}
  pack append .fsBox.path.paths               .fsBox.path.paths.paths {left}
  pack append .fsBox.pattern.patterns               .fsBox.pattern.patterns.patterns {left}
  pack append .fsBox.path               .fsBox.path.paths {left}               .fsBox.path.path {left fill expand}
  pack append .fsBox.pattern               .fsBox.pattern.patterns {left}               .fsBox.pattern.all {right fill}               .fsBox.pattern.pattern {left fill expand}
  if {$fsBox(showPixmap)} {
    pack append .fsBox.frame2                 .fsBox.frame2.scrollbar1 {left filly}                 .fsBox.frame2.canvas2 {top expand fill}                 .fsBox.frame2.scrollbar3 {top fillx} 

    pack append .fsBox                 .fsBox.message1 {top fill}                 .fsBox.frame1 {bottom fill}                 .fsBox.pattern {bottom fill}                 .fsBox.file {bottom fill}                 .fsBox.path {bottom fill}                 .fsBox.frame2 {right fill}                 .fsBox.files {left fill expand}
  } {
    pack append .fsBox                 .fsBox.message1 {top fill}                 .fsBox.frame1 {bottom fill}                 .fsBox.pattern {bottom fill}                 .fsBox.file {bottom fill}                 .fsBox.path {bottom fill}                 .fsBox.files {left fill expand}
  }

  if {"$fsBoxActionOk" == "" && "$fsBoxActionCancel" == ""} {
    # wait for the box to be destroyed
    update idletask
    grab .fsBox
    tkwait window .fsBox

    if {"[string trim $fsBox(path)]" != "" ||
        "[string trim $fsBox(name)]" != ""} {
      if {"[string trimleft [string trim $fsBox(name)] /]" == ""} {
        return [string trimright [string trim $fsBox(path)] /]
      } {
        return [string trimright [string trim $fsBox(path)] /]/[string trimleft [string trim $fsBox(name)] /]
      }
    }
  }
}


# Procedure: FSBoxBindSelectOne
proc FSBoxBindSelectOne { fsBoxW fsBoxY} {
# xf ignore me 6

  set fsBoxNearest [$fsBoxW nearest $fsBoxY]
  if {$fsBoxNearest >= 0} {
    $fsBoxW select from $fsBoxNearest
    $fsBoxW select to $fsBoxNearest
  }
}


# Procedure: FSBoxFSFileSelect
proc FSBoxFSFileSelect { fsBoxW fsBoxShowPixmap fsBoxY} {
# xf ignore me 6
  global fsBox

  FSBoxBindSelectOne $fsBoxW $fsBoxY
  set fsBoxNearest [$fsBoxW nearest $fsBoxY]
  if {$fsBoxNearest >= 0} {
    set fsBoxTmpEntry [$fsBoxW get $fsBoxNearest]
    if {"[string index $fsBoxTmpEntry           [expr [string length $fsBoxTmpEntry]-1]]" == "/" ||
        "[string index $fsBoxTmpEntry           [expr [string length $fsBoxTmpEntry]-1]]" == "@"} {
      set fsBoxFileName [string range $fsBoxTmpEntry 0             [expr [string length $fsBoxTmpEntry]-2]]
      if {![IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]] &&
          ![IsASymlink [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
        set fsBoxFileName $fsBoxTmpEntry
      }
    } {
      if {"[string index $fsBoxTmpEntry             [expr [string length $fsBoxTmpEntry]-1]]" == "*"} {
        set fsBoxFileName [string range $fsBoxTmpEntry 0           [expr [string length $fsBoxTmpEntry]-2]]
        if {![file executable $fsBox(internalPath)/$fsBoxFileName]} {
          set fsBoxFileName $fsBoxTmpEntry
        }
      } {
        set fsBoxFileName $fsBoxTmpEntry
      }
    }
    if {![IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
      set fsBox(name) $fsBoxFileName
      .fsBox.file.file delete 0 end
      .fsBox.file.file insert 0 $fsBox(name)
      if {$fsBoxShowPixmap} {
        catch ".fsBox.frame2.canvas2 itemconfigure currentBitmap -bitmap \"@$fsBox(internalPath)/$fsBox(name)\""
      }
    }
  }
}


# Procedure: FSBoxFSFileSelectDouble
proc FSBoxFSFileSelectDouble { fsBoxW fsBoxShowPixmap fsBoxAction fsBoxY} {
# xf ignore me 6
  global fsBox

  FSBoxBindSelectOne $fsBoxW $fsBoxY
  set fsBoxNearest [$fsBoxW nearest $fsBoxY]
  if {$fsBoxNearest >= 0} {
    set fsBoxTmpEntry [$fsBoxW get $fsBoxNearest]
    if {"$fsBoxTmpEntry" == "../"} {
      set fsBoxTmpEntry [string trimright [string trim $fsBox(internalPath)] "@/"]
      if {"$fsBoxTmpEntry" == ""} {
        return
      }
      FSBoxFSShow [file dirname $fsBoxTmpEntry]         [.fsBox.pattern.pattern get] $fsBox(all)
      .fsBox.path.path delete 0 end
      .fsBox.path.path insert 0 $fsBox(internalPath)
    } {
      if {"[string index $fsBoxTmpEntry             [expr [string length $fsBoxTmpEntry]-1]]" == "/" ||
          "[string index $fsBoxTmpEntry             [expr [string length $fsBoxTmpEntry]-1]]" == "@"} {
        set fsBoxFileName [string range $fsBoxTmpEntry 0               [expr [string length $fsBoxTmpEntry]-2]]
        if {![IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]] &&
            ![IsASymlink [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
          set fsBoxFileName $fsBoxTmpEntry
        }
      } {
        if {"[string index $fsBoxTmpEntry               [expr [string length $fsBoxTmpEntry]-1]]" == "*"} {
          set fsBoxFileName [string range $fsBoxTmpEntry 0                 [expr [string length $fsBoxTmpEntry]-2]]
          if {![file executable $fsBox(internalPath)/$fsBoxFileName]} {
            set fsBoxFileName $fsBoxTmpEntry
          }
        } {
          set fsBoxFileName $fsBoxTmpEntry
        }
      }
      if {[IsADir [string trimright $fsBox(internalPath)/$fsBoxFileName @]]} {
        set fsBox(internalPath) "[string trimright $fsBox(internalPath) {/@}]/$fsBoxFileName"
        FSBoxFSShow $fsBox(internalPath)           [.fsBox.pattern.pattern get] $fsBox(all)
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 $fsBox(internalPath)
      } {
        set fsBox(name) $fsBoxFileName
        if {$fsBoxShowPixmap} {
          set fsBox(path) @$fsBox(internalPath)
        } {
          set fsBox(path) $fsBox(internalPath)
        }
        if {"$fsBoxAction" != ""} {
          eval "global fsBox; $fsBoxAction"
        }
        if {"[info commands XFDestroy]" != ""} {
          catch {XFDestroy .fsBox}
        } {
          catch {destroy .fsBox}
        }
      }
    }
  }
}


# Procedure: FSBoxFSInsertPath
proc FSBoxFSInsertPath {} {
# xf ignore me 6
  global fsBox

  set fsBoxLast [.fsBox.path.paths.paths.menu index last]
  set fsBoxNewEntry [string trimright [.fsBox.path.path get] "/@"]
  for {set fsBoxCounter 0} {$fsBoxCounter <= $fsBoxLast} {incr fsBoxCounter 1} {
    if {"$fsBoxNewEntry" ==           "[lindex [.fsBox.path.paths.paths.menu entryconfigure                     $fsBoxCounter -label] 4]"} {
      return
    }
  }
  if {$fsBoxLast < 9} {
    .fsBox.path.paths.paths.menu add command       -label "$fsBoxNewEntry"       -command "
        global fsBox
        FSBoxFSShow $fsBoxNewEntry           \[.fsBox.pattern.pattern get\] \$fsBox(all)
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 $fsBoxNewEntry"
  } {
    for {set fsBoxCounter 0} {$fsBoxCounter < $fsBoxLast} {incr fsBoxCounter 1} {
      .fsBox.path.paths.paths.menu entryconfigure         $fsBoxCounter -label           [lindex [.fsBox.path.paths.paths.menu entryconfigure             [expr $fsBoxCounter+1] -label] 4]
      .fsBox.path.paths.paths.menu entryconfigure $fsBoxCounter         -command "
          global fsBox
          FSBoxFSShow [lindex [.fsBox.path.paths.paths.menu entryconfigure             [expr $fsBoxCounter+1] -label] 4]             \[.fsBox.pattern.pattern get\] \$fsBox(all)
          .fsBox.path.path delete 0 end
          .fsBox.path.path insert 0 [lindex             [.fsBox.path.paths.paths.menu entryconfigure               [expr $fsBoxCounter+1] -label] 4]"
    }
    .fsBox.path.paths.paths.menu entryconfigure $fsBoxLast       -label "$fsBoxNewEntry"
    .fsBox.path.paths.paths.menu entryconfigure $fsBoxCounter       -command "
        global fsBox
        FSBoxFSShow \[.fsBox.path.path get\]           \[.fsBox.pattern.pattern get\] \$fsBox(all)
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 $fsBoxNewEntry"
  }
}


# Procedure: FSBoxFSNameComplete
proc FSBoxFSNameComplete { fsBoxType} {
# xf ignore me 6
  global tkVersion
  global fsBox

  set fsBoxNewFile ""
  if {"$fsBoxType" == "path"} {
    set fsBoxDirName [file dirname [.fsBox.path.path get]]
    set fsBoxFileName [file tail [.fsBox.path.path get]]
  } {
    set fsBoxDirName [file dirname [.fsBox.path.path get]/]
    set fsBoxFileName [file tail [.fsBox.file.file get]]
  }

  set fsBoxNewFile ""
  if {[IsADir [string trimright $fsBoxDirName @]]} {
    catch "glob -nocomplain $fsBoxDirName/${fsBoxFileName}*" fsBoxResult
    foreach fsBoxCounter $fsBoxResult {
      if {"$fsBoxNewFile" == ""} {
        set fsBoxNewFile [file tail $fsBoxCounter]
      } {
        if {"[string index [file tail $fsBoxCounter] 0]" !=
            "[string index $fsBoxNewFile 0]"} {
          set fsBoxNewFile ""
          break
        }
        set fsBoxCounter1 0
        set fsBoxTmpFile1 $fsBoxNewFile
        set fsBoxTmpFile2 [file tail $fsBoxCounter]
        set fsBoxLength1 [string length $fsBoxTmpFile1]
        set fsBoxLength2 [string length $fsBoxTmpFile2]
        set fsBoxNewFile ""
        if {$fsBoxLength1 > $fsBoxLength2} {
          set fsBoxLength1 $fsBoxLength2
        }
        while {$fsBoxCounter1 < $fsBoxLength1} {
          if {"[string index $fsBoxTmpFile1 $fsBoxCounter1]" ==                 "[string index $fsBoxTmpFile2 $fsBoxCounter1]"} {
            append fsBoxNewFile [string index $fsBoxTmpFile1 $fsBoxCounter1]
          } {
            break
          }
          incr fsBoxCounter1 1
        }
      }
    }
  }
  if {"$fsBoxNewFile" != ""} {
    if {[IsADir [string trimright $fsBoxDirName/$fsBoxNewFile @]] ||
        ![IsAFile [string trimright $fsBoxDirName/$fsBoxNewFile @]]} {
      if {[IsADir [string trimright $fsBoxDirName/$fsBoxNewFile @]]} {
        if {"$fsBoxDirName" == "/"} {
          .fsBox.path.path delete 0 end
          .fsBox.path.path insert 0 "/[string trimright [string trim $fsBoxNewFile /] @]/"
        } {
          .fsBox.path.path delete 0 end
          .fsBox.path.path insert 0 "[string trimright $fsBoxDirName /]/[string trimright [string trim $fsBoxNewFile /] @]/"
        }
        FSBoxFSShow [.fsBox.path.path get]           [.fsBox.pattern.pattern get] $fsBox(all)
        FSBoxFSInsertPath
      } {
        .fsBox.path.path delete 0 end
        .fsBox.path.path insert 0 "[string trimright $fsBoxDirName /]/[string trimright [string trim $fsBoxNewFile /] @]"
      }
    } {
      .fsBox.path.path delete 0 end
      .fsBox.path.path insert 0 "[string trimright $fsBoxDirName {@/}]/"
      .fsBox.file.file delete 0 end
      .fsBox.file.file insert 0 $fsBoxNewFile
      if {$tkVersion >= 3.0} {
        .fsBox.file.file icursor end
      } {
        .fsBox.file.file cursor end
      }
      focus .fsBox.file.file
    }
  }
}


# Procedure: FSBoxFSShow
proc FSBoxFSShow { fsBoxPath fsBoxPattern fsBoxAll} {
# xf ignore me 6
  global fsBox

  set tmpButtonOpt ""
  if {"$fsBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$fsBox(activeBackground)\" "
  }
  if {"$fsBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$fsBox(activeForeground)\" "
  }
  if {"$fsBox(background)" != ""} {
    append tmpButtonOpt "-background \"$fsBox(background)\" "
  }
  if {"$fsBox(font)" != ""} {
    append tmpButtonOpt "-font \"$fsBox(font)\" "
  }
  if {"$fsBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$fsBox(foreground)\" "
  }

  set fsBox(pattern) $fsBoxPattern
  if {[file exists $fsBoxPath] && [file readable $fsBoxPath] &&
      [IsADir $fsBoxPath]} {
    set fsBox(internalPath) $fsBoxPath
  } {
    if {[file exists $fsBoxPath] && [file readable $fsBoxPath] &&
        [IsAFile $fsBoxPath]} {
      set fsBox(internalPath) [file dirname $fsBoxPath]
      .fsBox.file.file delete 0 end
      .fsBox.file.file insert 0 [file tail $fsBoxPath]
      set fsBoxPath $fsBox(internalPath)
    } {
      while {"$fsBoxPath" != "" && "$fsBoxPath" != "/" &&
             ![file isdirectory $fsBoxPath]} {
        set fsBox(internalPath) [file dirname $fsBoxPath]
         set fsBoxPath $fsBox(internalPath)
      }
    }
  }
  if {"$fsBoxPath" == ""} {
    set fsBoxPath "/"
    set fsBox(internalPath) "/"
  }
  .fsBox.path.path delete 0 end
  .fsBox.path.path insert 0 $fsBox(internalPath)

  if {[.fsBox.files.files size] > 0} {
    .fsBox.files.files delete 0 end
  }
  if {$fsBoxAll} {
    if {[catch "exec ls -F -a $fsBoxPath" fsBoxResult]} {
      puts stderr "$fsBoxResult"
    }
  } {
    if {[catch "exec ls -F $fsBoxPath" fsBoxResult]} {
      puts stderr "$fsBoxResult"
    }
  }
  set fsBoxElementList [lsort $fsBoxResult]

  foreach fsBoxCounter [winfo children .fsBox.pattern.patterns.patterns] {
    if {[string length [info commands XFDestroy]] > 0} {
      catch {XFDestroy $fsBoxCounter}
    } {
      catch {destroy $fsBoxCounter}
    }
  }
  menu .fsBox.pattern.patterns.patterns.menu
  catch ".fsBox.pattern.patterns.patterns.menu config $tmpButtonOpt"

  if {$fsBox(extensions)} {
    .fsBox.pattern.patterns.patterns.menu add command       -label "*"       -command {
        global fsBox
        set fsBox(pattern) "*"
        .fsBox.pattern.pattern delete 0 end
        .fsBox.pattern.pattern insert 0 $fsBox(pattern)
        FSBoxFSShow [.fsBox.path.path get] $fsBox(pattern)           $fsBox(all)}
  }

  if {"$fsBoxPath" != "/"} {
    .fsBox.files.files insert end "../"
  }
  foreach fsBoxCounter $fsBoxElementList {
    if {[string match $fsBoxPattern $fsBoxCounter] ||
        [IsADir [string trimright $fsBoxPath/$fsBoxCounter "/@"]]} {
      if {"$fsBoxCounter" != "../" &&
          "$fsBoxCounter" != "./"} {
        .fsBox.files.files insert end $fsBoxCounter
      }
    }

    if {$fsBox(extensions)} {
      catch "file rootname $fsBoxCounter" fsBoxRootName
      catch "file extension $fsBoxCounter" fsBoxExtension
      set fsBoxExtension [string trimright $fsBoxExtension "/*@"]
      if {"$fsBoxExtension" != "" && "$fsBoxRootName" != ""} {
        set fsBoxInsert 1
        set fsBoxLast [.fsBox.pattern.patterns.patterns.menu index last]
        for {set fsBoxCounter1 0} {$fsBoxCounter1 <= $fsBoxLast} {incr fsBoxCounter1 1} {
          if {"*$fsBoxExtension" ==                 "[lindex [.fsBox.pattern.patterns.patterns.menu entryconfigure                         $fsBoxCounter1 -label] 4]"} {
            set fsBoxInsert 0
          }
        }
	if {$fsBoxInsert} {
          .fsBox.pattern.patterns.patterns.menu add command             -label "*$fsBoxExtension"             -command "
              global fsBox
              set fsBox(pattern) \"*$fsBoxExtension\"
              .fsBox.pattern.pattern delete 0 end
              .fsBox.pattern.pattern insert 0 \$fsBox(pattern)
              FSBoxFSShow \[.fsBox.path.path get\] \$fsBox(pattern)                 \$fsBox(all)"
        }
      }
    }
  }
  if {$fsBox(extensions)} {
    .fsBox.pattern.patterns.patterns.menu add separator
  }
  if {$fsBox(extensions) || 
      "[.fsBox.pattern.patterns.patterns.menu index last]" == "none"} {
    .fsBox.pattern.patterns.patterns.menu add checkbutton       -label "Scan extensions"       -variable "fsBox(extensions)"       -command {
        global fsBox
        FSBoxFSShow [.fsBox.path.path get]           [.fsBox.pattern.pattern get] $fsBox(all)}
  }
}


# Procedure: FdInText
proc FdInText { textWidget {fileInFile ""}} {
# xf ignore me 5
##########
# Procedure: FdInText
# Description: fill a text with the contents of a filedescriptor
# Arguments: textWidget - the widget
#            {fileInFile} - a filedescriptor to read. The descriptor
#                           is closed after reading
# Returns: none
# Sideeffects: the text widget is filled
# Notes: there exists also a function called:
#          FileInText - to open and read a file automatically
##########

  # check file existance
  if {"$fileInFile" == ""} {
    puts stderr "no filedescriptor specified"
    return
  }

  set textValue [read $fileInFile]
  $textWidget insert end "$textValue"
  close $fileInFile
}


# Procedure: FileInText
proc FileInText { textWidget {fileName ""}} {
# xf ignore me 5
##########
# Procedure: FileInText
# Description: fill a text with the contents of the file
# Arguments: textWidget - the widget
#            {fileName} - filename to read
# Returns: none
# Sideeffects: the text widget is filled
# Notes: there exists also a function called:
#          FdInText - to read from an already opened filedescriptor
##########

  # check file existance
  if {"$fileName" == ""} {
    puts stderr "no filename specified"
    return
  }
  if {[catch "open $fileName r" fileInFile]} {
    puts stderr "$fileInFile"
    return
  }

  set textValue [read $fileInFile]
  $textWidget insert end "$textValue"
  close $fileInFile
}


# Procedure: IsADir
proc IsADir { pathName} {
# xf ignore me 5
##########
# Procedure: IsADir
# Description: check if name is a directory (including symbolic links)
# Arguments: pathName - the path to check
# Returns: 1 if its a directory, otherwise 0
# Sideeffects: none
##########

  if {[file isdirectory $pathName]} {
    return 1
  } {
    catch "file type $pathName" fileType
    if {"$fileType" == "link"} {
      if {[catch "file readlink $pathName" linkName]} {
        return 0
      }
      catch "file type $linkName" fileType
      while {"$fileType" == "link"} {
        if {[catch "file readlink $linkName" linkName]} {
          return 0
        }
        catch "file type $linkName" fileType
      }
      return [file isdirectory $linkName]
    }
  }
  return 0
}


# Procedure: IsAFile
proc IsAFile { fileName} {
# xf ignore me 5
##########
# Procedure: IsAFile
# Description: check if filename is a file (including symbolic links)
# Arguments: fileName - the filename to check
# Returns: 1 if its a file, otherwise 0
# Sideeffects: none
##########

  if {[file isfile $fileName]} {
    return 1
  } {
    catch "file type $fileName" fileType
    if {"$fileType" == "link"} {
      if {[catch "file readlink $fileName" linkName]} {
        return 0
      }
      catch "file type $linkName" fileType
      while {"$fileType" == "link"} {
        if {[catch "file readlink $linkName" linkName]} {
          return 0
        }
        catch "file type $linkName" fileType
      }
      return [file isfile $linkName]
    }
  }
  return 0
}


# Procedure: IsASymlink
proc IsASymlink { fileName} {
# xf ignore me 5
##########
# Procedure: IsASymlink
# Description: check if filename is a symbolic link
# Arguments: fileName - the path/filename to check
# Returns: none
# Sideeffects: none
##########

  catch "file type $fileName" fileType
  if {"$fileType" == "link"} {
    return 1
  }
  return 0
}


# Procedure: OptionButtonGet
proc OptionButtonGet { widget} {

  if {"[winfo class $widget.value]" == "Label"} {
    return [lindex [$widget.value config -text] 4]
  } {
    if {"[winfo class $widget.value]" == "Entry"} {
      return [$widget.value get]
    }
  }
}


# Procedure: OptionButtonSet
proc OptionButtonSet { widget} {

  if {"[winfo class $widget.value]" == "Label"} {
    $widget.value config -text [lindex [$widget.menubutton2.m entryconfig [$widget.menubutton2.m index active] -label] 4]
  } {
    if {"[winfo class $widget.value]" == "Entry"} {
      $widget.value delete 0 end
      $widget.value insert 0 [lindex [$widget.menubutton2.m entryconfig [$widget.menubutton2.m index active] -label] 4]
    }
  }
}


# Procedure: YesNoBox
proc YesNoBox { {yesNoBoxMessage "Yes/no message"} {yesNoBoxGeometry "350x150"}} {
# xf ignore me 5
##########
# Procedure: YesNoBox
# Description: show yesno box
# Arguments: {yesNoBoxMessage} - the text to display
#            {yesNoBoxGeometry} - the geometry for the window
# Returns: none
# Sideeffects: none
##########
#
# global yesNoBox(activeBackground) - active background color
# global yesNoBox(activeForeground) - active foreground color
# global yesNoBox(anchor) - anchor for message box
# global yesNoBox(background) - background color
# global yesNoBox(font) - message font
# global yesNoBox(foreground) - foreground color
# global yesNoBox(justify) - justify for message box
# global yesNoBox(afterNo) - destroy yes-no box after n seconds.
#                            The no button is activated
# global yesNoBox(afterYes) - destroy yes-no box after n seconds.
#                             The yes button is activated

  global yesNoBox

  set tmpButtonOpt ""
  set tmpFrameOpt ""
  set tmpMessageOpt ""
  if {"$yesNoBox(activeBackground)" != ""} {
    append tmpButtonOpt "-activebackground \"$yesNoBox(activeBackground)\" "
  }
  if {"$yesNoBox(activeForeground)" != ""} {
    append tmpButtonOpt "-activeforeground \"$yesNoBox(activeForeground)\" "
  }
  if {"$yesNoBox(background)" != ""} {
    append tmpButtonOpt "-background \"$yesNoBox(background)\" "
    append tmpFrameOpt "-background \"$yesNoBox(background)\" "
    append tmpMessageOpt "-background \"$yesNoBox(background)\" "
  }
  if {"$yesNoBox(font)" != ""} {
    append tmpButtonOpt "-font \"$yesNoBox(font)\" "
    append tmpMessageOpt "-font \"$yesNoBox(font)\" "
  }
  if {"$yesNoBox(foreground)" != ""} {
    append tmpButtonOpt "-foreground \"$yesNoBox(foreground)\" "
    append tmpMessageOpt "-foreground \"$yesNoBox(foreground)\" "
  }

  # start build of toplevel
  if {"[info commands XFDestroy]" != ""} {
    catch {XFDestroy .yesNoBox}
  } {
    catch {destroy .yesNoBox}
  }
  toplevel .yesNoBox     -borderwidth 0
  catch ".yesNoBox config $tmpFrameOpt"
  if {[catch "wm geometry .yesNoBox $yesNoBoxGeometry"]} {
    wm geometry .yesNoBox 350x150
  }
  wm title .yesNoBox {Alert box}
  wm maxsize .yesNoBox 1000 1000
  wm minsize .yesNoBox 100 100
  # end build of toplevel

  message .yesNoBox.message1     -anchor "$yesNoBox(anchor)"     -justify "$yesNoBox(justify)"     -relief raised     -text "$yesNoBoxMessage"
  catch ".yesNoBox.message1 config $tmpMessageOpt"

  set xfTmpWidth     [string range $yesNoBoxGeometry 0 [expr [string first x $yesNoBoxGeometry]-1]]
  if {"$xfTmpWidth" != ""} {
    # set message size
    catch ".yesNoBox.message1 configure       -width [expr $xfTmpWidth-10]"
  } {
    .yesNoBox.message1 configure       -aspect 1500
  }

  frame .yesNoBox.frame1     -borderwidth 0     -relief raised
  catch ".yesNoBox.frame1 config $tmpFrameOpt"

  button .yesNoBox.frame1.button0     -text "Yes"     -command "
      global yesNoBox
      set yesNoBox(button) 1
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .yesNoBox}
      } {
        catch {destroy .yesNoBox}
      }"
  catch ".yesNoBox.frame1.button0 config $tmpButtonOpt"

  button .yesNoBox.frame1.button1     -text "No"     -command "
      global yesNoBox
      set yesNoBox(button) 0
      if {\"\[info commands XFDestroy\]\" != \"\"} {
        catch {XFDestroy .yesNoBox}
      } {
        catch {destroy .yesNoBox}
      }"
  catch ".yesNoBox.frame1.button1 config $tmpButtonOpt"

  pack append .yesNoBox.frame1               .yesNoBox.frame1.button0 {left fillx expand}               .yesNoBox.frame1.button1 {left fillx expand}

  # packing
  pack append .yesNoBox               .yesNoBox.frame1 {bottom fill}               .yesNoBox.message1 {top fill expand}

  if {$yesNoBox(afterYes) != 0} {
    after [expr $yesNoBox(afterYes)*1000]       "catch \".yesNoBox.frame1.button0 invoke\""
  }
  if {$yesNoBox(afterNo) != 0} {
    after [expr $yesNoBox(afterNo)*1000]       "catch \".yesNoBox.frame1.button1 invoke\""
  }

  # wait for the box to be destroyed
  update idletask
  grab .yesNoBox
  tkwait window .yesNoBox

  return $yesNoBox(button)
}


# Internal procedures


# Procedure: Alias
proc Alias { args} {
# xf ignore me 7
##########
# Procedure: Alias
# Description: establish an alias for a procedure
# Arguments: args - no argument means that a list of all aliases
#                   is returned. Otherwise the first parameter is
#                   the alias name, and the second parameter is
#                   the procedure that is aliased.
# Returns: nothing, the command that is bound to the alias or a
#          list of all aliases - command pairs. 
# Sideeffects: internalAliasList is updated, and the alias
#              proc is inserted
##########
  global internalAliasList

  if {[llength $args] == 0} {
    return $internalAliasList
  } {
    if {[llength $args] == 1} {
      set xfTmpIndex [lsearch $internalAliasList "[lindex $args 0] *"]
      if {$xfTmpIndex != -1} {
        return [lindex [lindex $internalAliasList $xfTmpIndex] 1]
      }
    } {
      if {[llength $args] == 2} {
        eval "proc [lindex $args 0] {args} {#xf ignore me 4
return \[eval \"[lindex $args 1] \$args\"\]}"
        set xfTmpIndex [lsearch $internalAliasList "[lindex $args 0] *"]
        if {$xfTmpIndex != -1} {
          set internalAliasList [lreplace $internalAliasList $xfTmpIndex $xfTmpIndex "[lindex $args 0] [lindex $args 1]"]
        } {
          lappend internalAliasList "[lindex $args 0] [lindex $args 1]"
        }
      } {
        error "Alias: wrong number or args: $args"
      }
    }
  }
}


# Procedure: GetSelection
if {"[info procs GetSelection]" == ""} {
proc GetSelection {} {
# xf ignore me 7
##########
# Procedure: GetSelection
# Description: get current selection
# Arguments: none
# Returns: none
# Sideeffects: none
##########

  # the save way
  set xfSelection ""
  catch "selection get" xfSelection
  if {"$xfSelection" == "selection doesn't exist or form \"STRING\" not defined"} {
    return ""
  } {
    return $xfSelection
  }
}
}


# Procedure: MenuPopupAdd
if {"[info procs MenuPopupAdd]" == ""} {
proc MenuPopupAdd { xfW xfButton xfMenu {xfModifier ""} {xfCanvasTag ""}} {
# xf ignore me 7
# the popup menu handling is from (I already gave up with popup handling :-):
#
# Copyright 1991,1992 by James Noble.
# Everyone is granted permission to copy, modify and redistribute.
# This notice must be preserved on all copies or derivates.
#
##########
# Procedure: MenuPopupAdd
# Description: attach a popup menu to widget
# Arguments: xfW - the widget
#            xfButton - the button we use
#            xfMenu - the menu to attach
#            {xfModifier} - a optional modifier
#            {xfCanvasTag} - a canvas tagOrId
# Returns: none
# Sideeffects: none
##########

  if {"$xfModifier" != ""} {
    set xfPressModifier "$xfModifier-"
    set xfMoveModifier "$xfModifier-"
    set xfReleaseModifier "Any-"
  } {
    set xfPressModifier ""
    set xfMoveModifier ""
    set xfReleaseModifier ""
  }

  if {"$xfCanvasTag" == ""} {
    if {[catch "bind $xfW \"<${xfPressModifier}ButtonPress-$xfButton>\"                   \"$xfMenu post %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    if {[catch "bind $xfW \"<${xfMoveModifier}B$xfButton-Motion>\"                   \"MenuPopupHandle $xfMenu %W %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    # we need these to counteract the effects of passive grabs :-(
    if {[catch "bind $xfW \"<${xfReleaseModifier}ButtonRelease-$xfButton>\"                   \"$xfMenu invoke active; $xfMenu unpost\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
  } {
    if {[catch "$xfW bind $xfCanvasTag \"<${xfPressModifier}ButtonPress-$xfButton>\"                   \"$xfMenu post %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    if {[catch "$xfW bind $xfCanvasTag \"<${xfMoveModifier}B$xfButton-Motion>\"                   \"MenuPopupHandle $xfMenu %W %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    # we need these to counteract the effects of passive grabs :-(
    if {[catch "$xfW bind $xfCanvasTag \"<${xfReleaseModifier}ButtonRelease-$xfButton>\"                   \"$xfMenu invoke active; $xfMenu unpost\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
  }
}
}


# Procedure: MenuPopupHandle
if {"[info procs MenuPopupHandle]" == ""} {
proc MenuPopupHandle { xfMenu xfW xfX xfY} {
# xf ignore me 7
##########
# Procedure: MenuPopupHandle
# Description: handle the popup menus
# Arguments: xfMenu - the menu to attach
#            xfW - the widget
#            xfX - the root x coordinate
#            xfY - the root x coordinate
# Returns: none
# Sideeffects: none
##########

  if {"[info commands $xfMenu]" != "" && [winfo ismapped $xfMenu]} {
    set xfPopMinX [winfo rootx $xfMenu]
    set xfPopMaxX [expr $xfPopMinX+[winfo width $xfMenu]]
    if {($xfX >= $xfPopMinX) &&  ($xfX <= $xfPopMaxX)} {
      $xfMenu activate @[expr $xfY-[winfo rooty $xfMenu]]
    } {
      $xfMenu activate none
    }
  }
}
}


# Procedure: NoFunction
if {"[info procs NoFunction]" == ""} {
proc NoFunction { args} {
# xf ignore me 7
##########
# Procedure: NoFunction
# Description: do nothing (especially with scales and scrollbars)
# Arguments: args - a number of ignored parameters
# Returns: none
# Sideeffects: none
##########
}
}


# Procedure: SN
if {"[info procs SN]" == ""} {
proc SN { {xfName ""}} {
# xf ignore me 7
##########
# Procedure: SN
# Description: map a symbolic name to the widget path
# Arguments: xfName
# Returns: the symbolic name
# Sideeffects: none
##########

  SymbolicName $xfName
}
}


# Procedure: SymbolicName
if {"[info procs SymbolicName]" == ""} {
proc SymbolicName { {xfName ""}} {
# xf ignore me 7
##########
# Procedure: SymbolicName
# Description: map a symbolic name to the widget path
# Arguments: xfName
# Returns: the symbolic name
# Sideeffects: none
##########

  global symbolicName

  if {"$xfName" != ""} {
    set xfArrayName ""
    append xfArrayName symbolicName ( $xfName )
    if {![catch "set \"$xfArrayName\"" xfValue]} {
      return $xfValue
    } {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "Unknown symbolic name:\n$xfName"
      } {
        puts stderr "XF error: unknown symbolic name:\n$xfName"
      }
    }
  }
  return ""
}
}


# Procedure: Unalias
proc Unalias { aliasName} {
# xf ignore me 7
##########
# Procedure: Unalias
# Description: remove an alias for a procedure
# Arguments: aliasName - the alias name to remove
# Returns: none
# Sideeffects: internalAliasList is updated, and the alias
#              proc is removed
##########
  global internalAliasList

  set xfIndex [lsearch $internalAliasList "$aliasName *"]
  if {$xfIndex != -1} {
    rename $aliasName ""
    set internalAliasList [lreplace $internalAliasList $xfIndex $xfIndex]
  }
}



# application parsing procedure
proc XFLocalParseAppDefs {xfAppDefFile} {
  global xfAppDefaults

  # basically from: Michael Moore
  if {[file exists $xfAppDefFile] &&
      [file readable $xfAppDefFile] &&
      "[file type $xfAppDefFile]" == "link"} {
    catch "file type $xfAppDefFile" xfType
    while {"$xfType" == "link"} {
      if {[catch "file readlink $xfAppDefFile" xfAppDefFile]} {
        return
      }
      catch "file type $xfAppDefFile" xfType
    }
  }
  if {!("$xfAppDefFile" != "" &&
        [file exists $xfAppDefFile] &&
        [file readable $xfAppDefFile] &&
        "[file type $xfAppDefFile]" == "file")} {
    return
  }
  if {![catch "open $xfAppDefFile r" xfResult]} {
    set xfAppFileContents [read $xfResult]
    close $xfResult
    foreach line [split $xfAppFileContents "\n"] {
      # backup indicates how far to backup.  It applies to the
      # situation where a resource name ends in . and when it
      # ends in *.  In the second case you want to keep the *
      # in the widget name for pattern matching, but you want
      # to get rid of the . if it is the end of the name. 
      set backup -2  
      set line [string trim $line]
      if {[string index $line 0] == "#" || "$line" == ""} {
        # skip comments and empty lines
        continue
      }
      set list [split $line ":"]
      set resource [string trim [lindex $list 0]]
      set i [string last "." $resource]
      set j [string last "*" $resource]
      if {$j > $i} { 
        set i $j
        set backup -1
      }
      incr i
      set name [string range $resource $i end]
      incr i $backup
      set widname [string range $resource 0 $i]
      set value [string trim [lindex $list 1]]
      if {"$widname" != "" && "$widname" != "*"} {
        # insert the widget and resourcename to the application
        # defaults list.
        set xfAppDefaults($widname:[string tolower $name]) $value
      }
    }
  }
}

# application loading procedure
proc XFLocalLoadAppDefs {xfClasses {xfPriority "startupFile"} {xfAppDefFile ""}} {
  global env

  if {"$xfAppDefFile" == ""} {
    set xfFileList ""
    if {[info exists env(XUSERFILESEARCHPATH)]} {
      append xfFileList [split $env(XUSERFILESEARCHPATH) :]
    }
    if {[info exists env(XAPPLRESDIR)]} {
      append xfFileList [split $env(XAPPLRESDIR) :]
    }
    if {[info exists env(XFILESEARCHPATH)]} {
      append xfFileList [split $env(XFILESEARCHPATH) :]
    }
    append xfFileList " /usr/lib/X11/app-defaults"
    append xfFileList " /usr/X11/lib/X11/app-defaults"

    foreach xfCounter1 $xfClasses {
      foreach xfCounter2 $xfFileList {
        set xfPathName $xfCounter2
        if {[regsub -all "%N" "$xfPathName" "$xfCounter1" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%T" "$xfPathName" "app-defaults" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%S" "$xfPathName" "" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%C" "$xfPathName" "" xfResult]} {
          set xfPathName $xfResult
        }
        if {[file exists $xfPathName] &&
            [file readable $xfPathName] &&
            ("[file type $xfPathName]" == "file" ||
             "[file type $xfPathName]" == "link")} {
          catch "option readfile $xfPathName $xfPriority"
          if {"[info commands XFParseAppDefs]" != ""} {
            XFParseAppDefs $xfPathName
          } {
            if {"[info commands XFLocalParseAppDefs]" != ""} {
              XFLocalParseAppDefs $xfPathName
            }
          }
        } {
          if {[file exists $xfCounter2/$xfCounter1] &&
              [file readable $xfCounter2/$xfCounter1] &&
              ("[file type $xfCounter2/$xfCounter1]" == "file" ||
               "[file type $xfCounter2/$xfCounter1]" == "link")} {
            catch "option readfile $xfCounter2/$xfCounter1 $xfPriority"
            if {"[info commands XFParseAppDefs]" != ""} {
              XFParseAppDefs $xfCounter2/$xfCounter1
            } {
              if {"[info commands XFLocalParseAppDefs]" != ""} {
                XFLocalParseAppDefs $xfCounter2/$xfCounter1
              }
            }
          }
        }
      }
    }
  } {
    # load a specific application defaults file
    if {[file exists $xfAppDefFile] &&
        [file readable $xfAppDefFile] &&
        ("[file type $xfAppDefFile]" == "file" ||
         "[file type $xfAppDefFile]" == "link")} {
      catch "option readfile $xfAppDefFile $xfPriority"
      if {"[info commands XFParseAppDefs]" != ""} {
        XFParseAppDefs $xfAppDefFile
      } {
        if {"[info commands XFLocalParseAppDefs]" != ""} {
          XFLocalParseAppDefs $xfAppDefFile
        }
      }
    }
  }
}

# application setting procedure
proc XFLocalSetAppDefs {{xfWidgetPath "."}} {
  global xfAppDefaults

  if {![info exists xfAppDefaults]} {
    return
  }
  foreach xfCounter [array names xfAppDefaults] {
    if {[string match "${xfWidgetPath}*" $xfCounter]} {
      set widname [string range $xfCounter 0 [expr [string first : $xfCounter]-1]]
      set name [string range $xfCounter [expr [string first : $xfCounter]+1] end]
      # Now lets see how many tcl commands match the name
      # pattern specified.
      set widlist [info command $widname]
      if {"$widlist" != ""} {
        foreach widget $widlist {
          # make sure this command is a widget.
          if {![catch "winfo id $widget"]} {
            catch "$widget configure -[string tolower $name] $xfAppDefaults($xfCounter)" 
          }
        }
      }
    }
  }
}

# class bindings


# initialize global variables
proc InitGlobals {} {
  global {arc_panel_arc_kind}
  set {arc_panel_arc_kind} {}
  global {arc_panel_curved}
  set {arc_panel_curved} {0}
  global {arc_panel_splinesteps}
  set {arc_panel_splinesteps} {12}
  global {arc_panel_weight}
  set {arc_panel_weight} {1}
  global {auto_conflict_mode}
  set {auto_conflict_mode} {1}
  global {checkbutton0}
  set {checkbutton0} {0}
  global {checkbutton8}
  set {checkbutton8} {0}
  global {checkbutton9}
  set {checkbutton9} {0}
  global {displayBlockedTrans}
  set {displayBlockedTrans} {1}
  global {displayConflictPlace}
  set {displayConflictPlace} {1}
  global {displayDifference}
  set {displayDifference} {1}
  global {displayEnabledTrans}
  set {displayEnabledTrans} {1}
  global {displayFiredArc}
  set {displayFiredArc} {1}
  global {filename}
  set {filename} {}
  global {fsBox}
  set {fsBox(activeBackground)} {}
  set {fsBox(activeForeground)} {}
  set {fsBox(all)} {0}
  set {fsBox(background)} {}
  set {fsBox(button)} {0}
  set {fsBox(extensions)} {0}
  set {fsBox(font)} {}
  set {fsBox(foreground)} {}
  set {fsBox(internalPath)} {/vanity/blk/class/912/build}
  set {fsBox(name)} {}
  set {fsBox(path)} {/vanity/blk/class/912/build}
  set {fsBox(pattern)} {*}
  set {fsBox(scrollActiveForeground)} {}
  set {fsBox(scrollBackground)} {}
  set {fsBox(scrollForeground)} {}
  set {fsBox(scrollSide)} {left}
  set {fsBox(showPixmap)} {0}
  global {label_display}
  set {label_display(place)} {0}
  set {label_display(trans)} {0}
  global {modeMessage}
  set {modeMessage} {}
  global {modeModify}
  set {modeModify} {}
  global {modeState}
  set {modeState} {Normal}
  global {place_panel_label}
  set {place_panel_label} {}
  global {place_panel_label_offset}
  set {place_panel_label_offset} {1 1}
  global {place_panel_marking}
  set {place_panel_marking} {0}
  global {place_panel_max_tokens}
  set {place_panel_max_tokens} {99}
  global {place_panel_min_tokens}
  set {place_panel_min_tokens} {0}
  global {result}
  set {result} {}
  global {state_scale_to}
  set {state_scale_to} {}
  global {statusMessage}
  set {statusMessage} {}
  global {trans_panel_fire_status}
  set {trans_panel_fire_status} {not enabled}
  global {trans_panel_inhibit}
  set {trans_panel_inhibit} {fire}
  global {trans_panel_label}
  set {trans_panel_label} {}
  global {trans_panel_label_offset}
  set {trans_panel_label_offset} {1 1}
  global {warningMessage}
  set {warningMessage} {}
  global {xpetri_panel_occurrence_max}
  set {xpetri_panel_occurrence_max} {}
  global {xpetri_panel_save_state_max}
  set {xpetri_panel_save_state_max} {}
  global {yesNoBox}
  set {yesNoBox(activeBackground)} {}
  set {yesNoBox(activeForeground)} {}
  set {yesNoBox(afterNo)} {0}
  set {yesNoBox(afterYes)} {0}
  set {yesNoBox(anchor)} {n}
  set {yesNoBox(background)} {}
  set {yesNoBox(button)} {0}
  set {yesNoBox(font)} {*times-bold-r-normal*24*}
  set {yesNoBox(foreground)} {}
  set {yesNoBox(justify)} {center}

  # please don't modify the following
  # variables. They are needed by xf.
  global {autoLoadList}
  set {autoLoadList(main.tcl)} {0}
  set {autoLoadList(xpetri.tcl)} {0}
  global {internalAliasList}
  set {internalAliasList} {}
  global {moduleList}
  set {moduleList(xpetri.tcl)} {}
  global {preloadList}
  set {preloadList(xfInternal)} {}
  global {symbolicName}
  set {symbolicName(arc_panel)} {.top5}
  set {symbolicName(arc_panel_splinesteps)} {.top5.frame.scale1}
  set {symbolicName(arc_panel_weight)} {.top5.frame.scale21}
  set {symbolicName(canvas)} {.frame0.frame0.canvas2}
  set {symbolicName(help_panel)} {.top3}
  set {symbolicName(help_panel_text)} {.top3.frame.text2}
  set {symbolicName(place_panel)} {.top0}
  set {symbolicName(place_panel_label)} {.top0.frame.frame.frame.text2}
  set {symbolicName(place_panel_marking)} {.top0.frame.frame3.scale21}
  set {symbolicName(place_panel_max_tokens)} {.top0.frame.frame3.scale5}
  set {symbolicName(place_panel_min_tokens)} {.top0.frame.frame3.scale4}
  set {symbolicName(root)} {.}
  set {symbolicName(state_scale)} {.frame0.frame2.frame1.scale3}
  set {symbolicName(trans_panel)} {.top1}
  set {symbolicName(trans_panel_label)} {.top1.frame.frame.frame.text2}
  set {symbolicName(xpetri_panel)} {.top2}
  set {symbolicName(xpetri_panel_splinesteps)} {.top2.scale1}
  global {xfWmSetPosition}
  set {xfWmSetPosition} {.top0 .top2 .top5 .top1 .}
  global {xfWmSetSize}
  set {xfWmSetSize} {.}
  global {xfAppDefToplevels}
  set {xfAppDefToplevels} {}
}

# initialize global variables
InitGlobals

# display/remove toplevel windows.
ShowWindow.

global xfShowWindow.top0
set xfShowWindow.top0 1
ShowWindow.top0

global xfShowWindow.top1
set xfShowWindow.top1 1
ShowWindow.top1

global xfShowWindow.top2
set xfShowWindow.top2 1
ShowWindow.top2

global xfShowWindow.top3
set xfShowWindow.top3 1
ShowWindow.top3

global xfShowWindow.top5
set xfShowWindow.top5 1
ShowWindow.top5

# load default bindings.
if {[info exists env(XF_BIND_FILE)] &&
    "[info procs XFShowHelp]" == ""} {
  source $env(XF_BIND_FILE)
}

# parse and apply application defaults.
XFLocalLoadAppDefs Xpetri
XFLocalSetAppDefs

# eof
#

