#
# Copyright (C) 1993 Brian Kahn, Steve O'Keefe, Bob Noel
# Copyright (C) 1993 All Rights Reserved
# Copyright (C) 1993 Thu May 13 1993
#
# Complete copyright is held by each of the authors
# Permission to distribute and use for educational purposes
#
# 

proc xpetriInit {} {
    # init
    global c x y lastX lastY
    global normal_arc_width bold_arc_width 
    global normal_place_width bold_place_width 
    global normal_trans_width bold_trans_width 
    global transX transY placeX placeY

    set x 0
    set y 0
    set lastX 0
    set lastY 0

    global filename netname cwd
    set filename ${cwd}/NoName
    set netname ${cwd}/NoName.net
    global fsBox
    set fsBox(path) $cwd
    set fsBox(pattern) *.net

    # symbolic names in xf?
    set c [SN canvas]

    wm withdraw [SN arc_panel]
    wm withdraw [SN place_panel]
    wm withdraw [SN trans_panel]
    wm withdraw [SN xpetri_panel]
    wm withdraw [SN help_panel]

    # when init is executed, we are in the load directory
    FileInText [SN help_panel_text] doc/xpetriHelp

    set normal_arc_width 1
    set bold_arc_width 3
    set normal_place_width 2
    set bold_place_width 4
    set normal_trans_width 2
    set bold_trans_width 4

    set transX 16
    set transY 8
    set placeX 16
    set placeY 16

    global high_place_color high_trans_color high_arc_color high_text_color
    global normal_place_color normal_trans_color normal_arc_color normal_text_color
    if {[tk colormodel .]=="color"} {
    	# highlight
    	set high_place_color DodgerBlue
    	set high_trans_color DodgerBlue
    	set high_arc_color DodgerBlue
    	set high_text_color DodgerBlue
    	# normal
    	set normal_place_color SkyBlue2
    	set normal_trans_color SkyBlue3
    	set normal_arc_color black
    	set normal_text_color black
    } else {
    	# highlight
    	set high_place_color black
    	set high_trans_color black
    	set high_arc_color black
    	set high_text_color black
    	# normal
    	set normal_place_color white
    	set normal_trans_color white
    	set normal_arc_color black
    	set normal_text_color black
    }    	

    global arcSplinesteps
    set arcSplinesteps 18

    global label_display
    set label_display(place) 1
    set label_display(trans) 1

    global canvasColor
    set canvasColor [lindex [$c configure -background] 4]

    global placeCnt transCnt
    set placeCnt 0
    set transCnt 0

    global state_list state_cnt state_current state_id history
    set state_list {}
    set state_cnt 0
    set state_current 0
    set state_id 0
    set history 1

    global marking_modified net_modified
    set marking_modified 0
    set net_modified 0

    global inhibitSet holdSet
    set inhibitSet {}
    set holdSet {}

    global occurrenceMax stateMax
    set occurrenceMax 999
    set stateMax 12

    # make the menubar work right
    set bar .frame0.frame1
    eval "tk_menuBar $bar [lreverse [winfo children $bar]]"

    modeNormal

    tk_bindForTraversal .
    # <Alt-Key> is the default
    bind . <Meta-Key> {tk_traverseToMenu %W %A}
    bind . <Key> {tk_traverseToMenu %W %A}

    # make canvas use xyScroll instead of "bar set ..."
    set xbar [lindex [lindex [$c configure -xscrollcommand] 4] 0]
    set ybar [lindex [lindex [$c configure -yscrollcommand] 4] 0]
    $c configure -xscrollcommand "xyScroll canvx $xbar"
    $c configure -yscrollcommand "xyScroll canvy $ybar"

    # scroll to the center "page"
    $c xview 88
    $c yview 120

    foreach point {
            {1046 1284 p1} 
            {1046 1374 t1}
            } {
        set x [lindex $point 0]
        set y [lindex $point 1]
        set z [lindex $point 2]
        if [regexp "p." $z] {
            new_place $x $y
        }
        if [regexp "t." [lindex $point 2]] {
            new_trans $x $y
        }
    }
    # set the initial state    
    stateSetInitial
    set net_modified 0
    markingRefresh
}



set cwd [pwd]
if [info exist env(XPETRI_DIR)] {
  set xpetri_dir $env(XPETRI_DIR)
} else {
  set xpetri_dir $cwd
}
cd $xpetri_dir

source xpetri.tcl
source xpetriModes.tcl
source xpetriDraw.tcl
source xpetriCode.tcl
option readfile XPetri.ad 66

xpetriInit
source xpetriBind.tcl

cd $cwd
