#
# Copyright (C) 1993 Brian Kahn, Steve O'Keefe, Bob Noel
# Copyright (C) 1993 All Rights Reserved
# Copyright (C) 1993 Thu May 13 1993
#
# Complete copyright is held by each of the authors
# Permission to distribute and use for educational purposes
#
# 

proc modeNormal {} {
    # Bindings for move mode
    global c modeState modeMessage statusMessage
    $c bind arc <1> "xySet %x %y; arcReshape"
    $c bind arc <2> "xySet %x %y; arcReshape"
    $c bind arc <3> "xySet %x %y; arcReshape"
    $c bind arc <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind arc <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind arc <B1-Motion> "xySetDrag %x %y; arcReshape"
    $c bind arc <B2-Motion> "xySetDrag %x %y; arcReshape"
    $c bind arc <B3-Motion> "xySetDrag %x %y; arcReshape"
    $c bind arc <ButtonRelease-1> ""
    $c bind arc <ButtonRelease-2> ""
    $c bind arc <ButtonRelease-3> ""
    $c bind place <1> ""
    $c bind place <2> "xySet %x %y; itemDup selected"
    $c bind place <3> "xySet %x %y; arcSrc selected"
    $c bind place <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind place <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind place <B1-Motion> "xySetDrag %x %y; itemMove"
    $c bind place <B2-Motion> "xySetDrag %x %y; itemMove"
    $c bind place <B3-Motion> "xySetDrag %x %y; arcStretch"
    $c bind place <ButtonRelease-1> ""
    $c bind place <ButtonRelease-2> ""
    $c bind place <ButtonRelease-3> "xySet %x %y; arcSink"
    $c bind trans <1> ""
    $c bind trans <2> "xySet %x %y; itemDup selected"
    $c bind trans <3> "xySet %x %y; arcSrc selected"
    $c bind trans <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind trans <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind trans <B1-Motion> "xySetDrag %x %y; itemMove"
    $c bind trans <B2-Motion> "xySetDrag %x %y; itemMove"
    $c bind trans <B3-Motion> "xySetDrag %x %y; arcStretch"
    $c bind trans <ButtonRelease-1> ""
    $c bind trans <ButtonRelease-2> ""
    $c bind trans <ButtonRelease-3> "xySet %x %y; arcSink"
    bind $c <1> "xySet %x %y"
    bind $c <2> "xySet %x %y"
    bind $c <3> "xySet %x %y"
    bind $c <B1-Motion> ""
    bind $c <B2-Motion> ""
    bind $c <B3-Motion> ""

    $c configure -cursor left_ptr
    set modeMessage {|Move| Copy |Arc|}
    set modeState {Normal}
    set statusMessage "Move or Copy Objects, Draw Arcs"
}


proc modeAddObjects {} {
    # Bindings for move mode
    global c modeState modeMessage statusMessage xpetri_dir
    $c bind arc <1> "xySet %x %y; arcReshape"
    $c bind arc <2> "xySet %x %y; arcReshape"
    $c bind arc <3> "xySet %x %y; arcReshape"
    $c bind arc <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind arc <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind arc <B1-Motion> "xySetDrag %x %y; arcReshape"
    $c bind arc <B2-Motion> "xySetDrag %x %y; arcReshape"
    $c bind arc <B3-Motion> "xySetDrag %x %y; arcReshape"
    $c bind arc <ButtonRelease-1> ""
    $c bind arc <ButtonRelease-2> ""
    $c bind arc <ButtonRelease-3> ""
    $c bind place <1> "itemUnselect current"
    $c bind place <2> "itemUnselect current"
    $c bind place <3> "xySet %x %y; arcSrc selected"
    $c bind place <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind place <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind place <B1-Motion> ""
    $c bind place <B2-Motion> ""
    $c bind place <B3-Motion> "xySet %x %y; arcStretch"
    $c bind place <ButtonRelease-1> ""
    $c bind place <ButtonRelease-2> ""
    $c bind place <ButtonRelease-3> "xySet %x %y; arcSink"
    $c bind trans <1> "itemUnselect current"
    $c bind trans <2> "itemUnselect current"
    $c bind trans <3> "xySet %x %y; arcSrc selected"
    $c bind trans <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind trans <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind trans <B1-Motion> ""
    $c bind trans <B2-Motion> ""
    $c bind trans <B3-Motion> "xySet %x %y; arcStretch"
    $c bind trans <ButtonRelease-1> ""
    $c bind trans <ButtonRelease-2> ""
    $c bind trans <ButtonRelease-3> "xySet %x %y; arcSink"
    bind $c <1> "xySet %x %y; new_transXY"
    bind $c <2> "xySet %x %y; new_placeXY"
    bind $c <3> "xySet %x %y"
    bind $c <B1-Motion> "xySetDrag %x %y; itemMove"
    bind $c <B2-Motion> "xySetDrag %x %y; itemMove"
    bind $c <B3-Motion> ""

    $c configure -cursor "
      	@${xpetri_dir}/bitmap/objects.bm 
      	${xpetri_dir}/bitmap/objectsMask.bm black gray
    "
    set modeMessage {|Trans|Place|Arc|}
    set modeState {AddObjects}
    set statusMessage "Add Transition, Place, or Arc"
}


proc modeModify {} {
    # Bindings for move mode
    global c modeState modeMessage statusMessage xpetri_dir
    $c bind arc <1> "weightAdjust selected"
    $c bind arc <2> "panelPop current"
    $c bind arc <3> "weightAdjust selected -1"
    $c bind arc <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind arc <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind arc <B1-Motion> ""
    $c bind arc <B2-Motion> ""
    $c bind arc <B3-Motion> ""
    $c bind arc <ButtonRelease-1> ""
    $c bind arc <ButtonRelease-2> ""
    $c bind arc <ButtonRelease-3> ""
    $c bind place <1> "markingAdjust selected"
    $c bind place <2> "panelPop current"
    $c bind place <3> "markingAdjust selected -1"
    $c bind place <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind place <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind place <B1-Motion> ""
    $c bind place <B2-Motion> ""
    $c bind place <B3-Motion> ""
    $c bind place <ButtonRelease-1> ""
    $c bind place <ButtonRelease-2> ""
    $c bind place <ButtonRelease-3> ""
    $c bind trans <1> "statusAdjust selected"
    $c bind trans <2> "panelPop current"
    $c bind trans <3> "statusAdjust selected -1"
    $c bind trans <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind trans <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind trans <B1-Motion> ""
    $c bind trans <B2-Motion> ""
    $c bind trans <B3-Motion> ""
    $c bind trans <ButtonRelease-1> ""
    $c bind trans <ButtonRelease-2> ""
    $c bind trans <ButtonRelease-3> ""
    bind $c <1> ""
    bind $c <2> ""
    bind $c <3> ""
    bind $c <B1-Motion> ""
    bind $c <B2-Motion> ""
    bind $c <B3-Motion> ""

    $c configure -cursor "
      	@${xpetri_dir}/bitmap/modify.bm 
      	${xpetri_dir}/bitmap/modifyMask.bm black gray
    "
    set modeMessage {|++| Modify |--|}
    set modeState {Modify}
    set statusMessage "Change Object Parameters"
}


proc modeKill {} {
    # Bindings for kill mode
    global c modeState modeMessage statusMessage
    $c bind arc <1> "killObject selected"
    $c bind arc <2> "killObject selected"
    $c bind arc <3> "killObject selected"
    $c bind arc <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind arc <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind arc <B1-Motion> ""
    $c bind arc <B2-Motion> ""
    $c bind arc <B3-Motion> ""
    $c bind arc <ButtonRelease-1> ""
    $c bind arc <ButtonRelease-2> ""
    $c bind arc <ButtonRelease-3> ""
    $c bind place <1> "killObject selected"
    $c bind place <2> "killObject selected"
    $c bind place <3> "killObject selected"
    $c bind place <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind place <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind place <B1-Motion> ""
    $c bind place <B2-Motion> ""
    $c bind place <B3-Motion> ""
    $c bind place <ButtonRelease-1> ""
    $c bind place <ButtonRelease-2> ""
    $c bind place <ButtonRelease-3> ""
    $c bind trans <1> "killObject selected"
    $c bind trans <2> "killObject selected"
    $c bind trans <3> "killObject selected"
    $c bind trans <Any-Enter> "itemHighlight current; itemSelect current"
    $c bind trans <Any-Leave> "itemUnhighlight current; itemUnselect current"
    $c bind trans <B1-Motion> ""
    $c bind trans <B2-Motion> ""
    $c bind trans <B3-Motion> ""
    $c bind trans <ButtonRelease-1> ""
    $c bind trans <ButtonRelease-2> ""
    $c bind trans <ButtonRelease-3> ""
    bind $c <1> ""
    bind $c <2> ""
    bind $c <3> ""
    bind $c <B1-Motion> ""
    bind $c <B2-Motion> ""
    bind $c <B3-Motion> ""

    $c configure -cursor pirate
    set modeMessage {|KILL|KILL|KILL|}
    set modeState {Kill}
    set statusMessage "Destroy Objects"
}


